; Zusatzmontitor Z9001 Version 3.01 (CP/M)
; 1986 F.Schwarzenberg 8036,Gamigstr.5
; reassembliert: V. Pohlers, 01.2009

; File Name   :	ZM301 B000.ROM
; Base Address:	0000h Range: B000h - BFFFh Loaded length: 1000h


; Unterschiede zur Beschreibung/Hinweise
; Kommando E -> Einzelschritt
; Kommando N -> CRC-Berechnung
; Es wird ein PIO-Modul mit 2 PIO initialisiert (cmd_cold2)
; PIO1C (FA, FB), PIO2C (FE, FF)

; TODO (weitere Reihenfolge zum Disassemblieren)
; ZM302 BITEX.rom
; ZM302 BOOT.rom
; ZM302 CPM.rom


		cpu	Z80

		include	z9001.inc
		include	os.inc

; Systemspeicher
KEYBU		equ	0025h		; Tastaturpuffer
PU		equ	002Fh		; Hilfszelle
;P1ROL		equ	003Bh		; 1. rollende Zeile - 1
;FCB		equ	005Ch		; Dateiname 8 Zeichen
FNAME		equ	005Ch
;FTYP		equ	0064h		; Dateityp 3 Zeichen
PSUM		equ	0069h		; Pruefsumme eines Datenblockes
;LBLNR		equ	006Ch		; gesuchte Blocknummer bei Lesen
AADR		equ	006Dh		; Dateianfangsadresse
EADR		equ	006Fh		; Dateiendeadresse
SADR		equ	0071h		; Startadresse,	wenn Datei ein Maschinencodeprogramm ist


varcass:	equ	0037h		; Hilfszelle CASS
varlist:	equ	0057h  		; Hilfszelle fr LIST
var1:		equ	0058h		; Hilfszelle Gertetreiber u.a.
varsav:		equ	005Ah		; Hilfszelle CASS-Save

		org 0B000h

beg:		equ	$

; Sprungverteiler

cmd_zm:		jp	init
cmd_rzm:	jp	trap
		jp	error
		jp	GIOBY		; ABFRAGE I/O-BYTE
		jp	SIOBY
		jp	eor0
		jp	getdez
		jp	todez
		jp	params
		jp	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		jp	bin_e
		jp	cass
		jp	bdos0

begdat:		dw 	beg		; Anfang
		dw 	aFlags		; Ende (??)
		dw 	0

;------------------------------------------------------------------------------
; I/O-BYTE
;------------------------------------------------------------------------------

; ABFRAGE I/O-BYTE
GIOBY:		ld	a, (4)		; ABFRAGE I/O-BYTE
		ret

; SETZEN I/O-BYTE
SIOBY:		ld	a, c
		ld	(4), a
		ret

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

eor0:		push	hl
		call	eor
		ld	a, l
		sub	3Ch ; '<'
		jr	nc, eor01
		dec	h
eor01:		ld	b, h
		pop	hl
		ret

eor:		push	bc
		ld	hl, reset	; Kaltstart
		ld	b, 40h ; '@'

eor2:		ld	a, (hl)
		cpl
		ld	(hl), a
		cp	(hl)
		cpl
		ld	(hl), a
		ld	c, 1
		jr	z, eor3
		dec	c
		ld	(55h), hl

eor3:		call	mod		; ndern logische Speicherkonfiguration
		djnz	eor2
		ld	de, (begdat)
		ld	hl, (55h)
		call	nextadr0
		jr	nc, eor4
		ex	de, hl

eor4:		dec	hl
		ld	bc, unk_FFDD
		add	hl, bc
		pop	bc
		ret

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

aZ9001Monitor3_:db 0Dh,0Ah
		db 0Ch,7," Z9001 MONITOR 3.01(CP/M)  FS 1986 ",0Dh,0Ah,0

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

init1:		ld	a, 0C3h			; "JP", RST 38 (TRAP) initialisieren
		ld	(38h), a
		ld	hl, cmd_rzm
		ld	(39h), hl
		ld	a, 10101000b		; IO-Byte setzen
		ld	(4), a
		call	eor
		ld	sp, hl
		ex	de, hl
		ld	bc, tab_reg-regrstor
		ld	hl, regrstor		; Register restaurieren
		ldir
		ex	de, hl
		ld	bc, -6Fh
		add	hl, bc
		push	hl
		ld	bc, -91h
		add	hl, bc
		ld	(36h), hl		; EOR
		ld	hl, 0
		ld	b, 9
init3:		push	hl
		djnz	init3
		ld	a, r
		ld	l, a
		ld	a, i
		ld	h, a
		push	hl
		ld	b, init1-aZ9001Monitor3_	; Lnge der Systemmeldung
		call	zmmsg			; Ausgabe der Systemmeldung
		call	kdo_u

;------------------------------------------------------------------------------
; Hauptschleife
;------------------------------------------------------------------------------

prompt:		ld	de, prompt
		push	de
		call	out_crlf
		ld	c, '='
		call	zm_conso	; Zeichenausgabe
		ld	c, '>'
		call	zm_conso	; Zeichenausgabe
prompt1:	call	zm_char		; Eingabe Buchstabe oder ENTER
		and	7Fh
		jr	z, prompt1
		sub	'A'		; A = 0..19h
		ret	m
		cp	1Ah
		ret	nc
		add	a, a
		ld	hl, kdo_tab
		add	a, l
		ld	l, a
		ld	a, h
		adc	a, 0
		ld	h, a
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a		; HL=Adr. Kommando
		ld	c, 2		; Std. 2 Parameter
		jp	(hl)		; Kommando starten

; Sprungverteiler ZM-Kommandos
kdo_tab:	dw kdo_a
		dw bye
		dw convert
		dw display
		dw step
		dw fill
		dw go
		dw kdo_h
		dw kdo_i
		dw kdo_j
		dw kdo_k
		dw kdo_l
		dw move
		dw crc			; !!!
		dw kdo_o
		dw punch
		dw kdo_q
		dw read
		dw Substitute
		dw Type
		dw kdo_u
		dw kdo_v
		dw error
		dw kdo_x
		dw kdo_y
		dw kdo_z
		
;------------------------------------------------------------------------------
; A   Geraetezuweisung
;       C fuer CONSOL
;       R fuer READER
;       P fuer PUNCH
;------------------------------------------------------------------------------

kdo_a:		call	zm_char		; Eingabe Buchstabe oder ENTER
		ld	hl, tab_asgn
		ld	bc, 400h	; B := 4, C := 0
		ld	de, 5
kdo_a1:		cp	(hl)		; Suche	Dest-Gert
		jr	z, kdo_a2
		add	hl, de
		inc	c
		djnz	kdo_a1		; Suche	Dest-Gert
		jr	kdo_a5
kdo_a2:		ld	e, c
kdo_a3:		call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	'='
		jr	nz, kdo_a3
		call	zm_char		; Eingabe Buchstabe oder ENTER
		ld	bc, 400h	; B := 4, C := 0
kdo_a4:		inc	hl
		cp	(hl)
		jr	z, kdo_a6
		inc	c
		djnz	kdo_a4
kdo_a5:		jp	error
;
kdo_a6:		ld	a, 3
		inc	e
kdo_a7:		dec	e
		jr	z, kdo_a8
		sla	c
		sla	c
		rla
		rla
		jr	kdo_a7
kdo_a8:		cpl
		ld	d, a
kdo_a9:		call	getch		; nchstes Zeichen lesen; Test auf Leerzeichen oder Enter
		jr	nc, kdo_a9
		ld	a, (4)
		and	d
		or	c
		ld	c, a
		jp	SIOBY		; SETZEN I/O-BYTE

;------------------------------------------------------------------------------
;  B   Rueckgabe an das OS
;------------------------------------------------------------------------------

bye:		jp	wboot		; Warmstart

;------------------------------------------------------------------------------
;O (Off CP/M):	Die Verarbeitung der BDOS-Rufe erfolgt wieder im Z9001-Mode.
;------------------------------------------------------------------------------

kdo_o:		ld	hl, bos		; Eintritt OS-BOS
		ld	(6), hl
		ld	h, 2
		jr	kdo_i2

;------------------------------------------------------------------------------
;I (Init CP/M):		I[Filename[.typ]]^
;			filename: max. 8 Buchstaben oder Zahlen
;			typ	: max. 3     "	      "	   "
;
;			Dieses Kommando	stellt CP/M-Kompatibilitt
;			fr Anwenderprogramme her. Programme knnen
;			jetzt ab der Anfangsadresse 100H geladen
;			werden (nicht mehr 300H!). Die Verarbeitung
;			der BDOS-Rufe erfolgt wie unter	CP/M blich.
;			Diskettenrufe werden auf Kassette umverlegt!
;			Zustzlich wird	der Standard-FCB (jetzt	ab
;			5CH) mit filename.typ initialisiert.
;------------------------------------------------------------------------------

kdo_i:		ld	de, FCB1	; Dateiname 8 Zeichen
		call	getfn		; Get Filename
kdo_i1:		ld	hl, 38h		; Call 0 -> RST38
		ld	(1), hl
		call	kdo_z		; hl = 7FFF
		dec	h		; h = 7E
		ld	l, 6Fh		; ??? woher kommt dieser Wert ???
		ld	(36h), hl	; EOR
		inc	l
		ld	(6), hl		; Call 5 (BDOS)	umhngen
		ld	a, 0C3h		; JMP
		ld	(hl), a
		ld	de, bdos	; Sprung zu BDOS-Verteiler eintragen
		inc	l
		ld	(hl), e
		inc	l
		ld	(hl), d
		inc	h
;
kdo_i2:		di
		ld	a, h
		ld	i, a		; I-Register umhngen
		ld	l, 0
		ex	de, hl
		ld	hl, 3
		add	hl, sp
		ld	(hl), d
		ld	hl, intv	; Interruptadresstabelle 
		ld	bc, 12		; kopieren
		ldir
		ei
		ret


;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

; Get Filename
getfn:		exx
		call	getms		; GETMS
		ret	c
		call	coext		; COEXT
		jr	nc, getfn1
		ld	a, ' '
		ld	(fcb1), a
		ld	(fcb2), a
		ret
;
getfn1:		exx
		ld	hl, CONBU+1
		ld	a, (hl)
		inc	a
		dec	l
		ld	(hl), a
		inc	l
		ld	(hl), ' '
		inc	l
		call	getfn3
		or	a
		jr	nz, getfn2
		ld	a, ' '
		ld	(fcb2), a
		ret
;
getfn2:		inc	hl
		ld	de, fcb2
;
getfn3:		xor	a
		ld	(de), a
		inc	de
		ld	b, 8
		call	getfn4
		call	nc, getfn6
		cp	'.'
		ld	b, 3
		jr	nz, getfn6
		inc	hl
		call	getfn4
		ret	c
		jr	getfn6
;
getfn4:		ld	a, (hl)
		or	a
		ret	z
		call	getfn5		; Test auf Trennzeichen
		ret	z
		ld	(de), a
		inc	de
		inc	hl
		djnz	getfn4
		ld	a, (hl)
		scf
		ret

; Test auf Trennzeichen
getfn5:		exx
		ld	hl, dtab	; Tabelle der Trennzeichen
		ld	bc, 5
		cpir
		exx
		ret
;
getfn6:		push	af
		ld	a, ' '
getfn7:		ld	(de), a
		inc	de
		djnz	getfn7
		pop	af
		or	a
		ret

;------------------------------------------------------------------------------
; kdo_n:	crc-Berechnung
;     		wohl nachtrglich hier reingepatcht
;		N aadr eadr
;------------------------------------------------------------------------------

crc:		ld	c, 2
		call	params
		cp	0Dh
		pop	bc
		pop	hl
		jp	nz, error
		push	bc
		ld	de, 0FFFFh
crc1:		ld	b, 80h
crc2:		sla	e
		rl	d
		sbc	a, a
		xor	(hl)
		and	b
		jp	z, crc3
		jp	crc4

;------------------------------------------------------------------------------
; C (Convert)  Umrechnung Dezimalzahl in Hexa-
;     dezimalzahl und umgekehrt
;       CD (dez. z.) Dez. = > Hex.
;       CH (hex. z.) Hex. = > Dez.
;------------------------------------------------------------------------------

convert:	call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	'D'
		jr	nz, convert1
		ld	hl, error
		push	hl
;
getdez:		ld	hl, 0
getdez1:	call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	30h ; '0'
		jr	c, getdez2
		cp	3Ah ; ':'
		jr	nc, getdez2
		sub	30h ; '0'
		ld	d, h
		ld	e, l
		add	hl, hl
		ret	c
		add	hl, hl
		ret	c
		add	hl, de
		ret	c
		add	hl, hl
		ret	c
		ld	d, 0
		ld	e, a
		add	hl, de
		ret	c
		jr	getdez1
;
getdez2:	pop	de
		call	outsp		; Leerzeichen ausgeben
		call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen
		ld	c, 'H'
		jp	zm_conso	; Zeichenausgabe
;
convert1:	call	param
		pop	hl
;
todez:		ld	b, 10h
		ld	de, 0
		ld	c, e
todez1:		add	hl, hl
		ld	a, e
		adc	a, e
		daa
		ld	e, a
		ld	a, d
		adc	a, d
		daa
		ld	d, a
		ld	a, c
		adc	a, c
		ld	c, a
		djnz	todez1
		ld	b, c
		call	outsp		; Leerzeichen ausgeben
		ld	a, b
		or	a
		jr	z, todez2
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
todez2:		ex	de, hl
		call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen
		ld	c, 'D'
		jp	zm_conso	; Zeichenausgabe

;------------------------------------------------------------------------------
; zu kdo_v
;------------------------------------------------------------------------------

; Anzeige HL, (HL), A
outmem:		ld	b, a
		call	outhlsp
		ld	a, (hl)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		call	outsp		; Leerzeichen ausgeben
		ld	a, b
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		jp	out_crlf

;------------------------------------------------------------------------------
; D (Display) Ausgabe von Speicherbereichen
;     auf Konsole  (in Hex- und ASCII (ab Vers.3)-Integration)
;       D anfadr_endadr
;------------------------------------------------------------------------------


display:	call	twoparams
display1:	call	outnlhlsp	; Ausgabe CR,LF, HL hexa 4 Stellen, SP
		call	display2
		ld	a, l
		and	7
		ld	b, a
		ld	a, 8
		sub	b
		ld	b, a
		call	outsp		; Leerzeichen ausgeben
		call	type3
		ret	c
		jr	display1
;
display2:	push	hl
display3:	call	outsp		; Leerzeichen ausgeben
		ld	a, (hl)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		inc	hl
		ld	a, l
		and	7
		jr	nz, display3
		pop	hl
		ret

;------------------------------------------------------------------------------
; weiter zu CRC
;------------------------------------------------------------------------------

crc4:		ld	a, e
		xor	21h ; '!'
		ld	e, a
		ld	a, d
		xor	10h
		ld	d, a
crc3:		srl	b
		jp	nc, crc2
		pop	bc
		push	bc
		xor	a
		sbc	hl, bc
		add	hl, bc
		inc	hl
		jp	nz, crc1
		ex	de, hl
		ld	de, aCrcSdlc	; "\nCRC (SDLC)="
		ld	c, 9
		jp	crc5
;
;
		or	(hl)

;------------------------------------------------------------------------------
; F   Beschreiben eines Speicherbe-
;     reiches mit konst. Wert
;       F anfadr_endadr_wert
;------------------------------------------------------------------------------

fill:		call	threeparams
fill1:		ld	(hl), c
		call	nextadr		; incl HL, HL=0	oder HL=DE?
		jr	nc, fill1
		pop	de
		jp	prompt

;------------------------------------------------------------------------------
; G (Go): Start eines Anwenderprogrammes mit max.
; 	zwei. Haltepunkten.
; 
; 	G<startadr>[_<break1>][_<break2>](_^)
;------------------------------------------------------------------------------

go:		call	getch
		jr	c, go5
		jr	z, go1
		call	param1		; 1 Parameter holen; das aktuelle Zeichen gehrt schon zum Parameter
		pop	de
		ld	hl, 34h		; ???
		add	hl, sp
		ld	(hl), d
		dec	hl
		ld	(hl), e
		ld	a, b
		cp	0Dh
		jr	z, go5
go1:		ld	d, 2
		ld	hl, 35h		; ???
		add	hl, sp
go2:		push	hl
		call	param		; 1 Parameter holen
		ld	e, b
		pop	bc
		pop	hl
		ld	a, b
		or	c
		jr	z, go3
		ld	(hl), c
		inc	hl
		ld	(hl), b
		inc	hl
		ld	a, (bc)
		ld	(hl), a
		inc	hl
		ld	a, 0FFh
		ld	(bc), a
go3:		ld	a, e
		cp	0Dh
		jr	z, go4
		dec	d
		jr	nz, go2
go4:		ld	a, 0C3h		; JP
		ld	(38h), a	; RST38 (TRAP)
		ld	hl, cmd_rzm
		ld	(39h), hl
go5:		call	out_crlf
		pop	de
		ld	hl, 16h		; ???
		add	hl, sp
		jp	(hl)

;------------------------------------------------------------------------------
; J   Nichtzerstoerender Speichertest
;       J anfadr_endadr
;------------------------------------------------------------------------------

kdo_j:		call	twoparams
kdo_j1:		ld	a, (hl)
		ld	b, a
		cpl
		ld	(hl), a
		xor	(hl)
		jr	z, kdo_j2
		push	de
		ld	d, b
		ld	e, a
		call	outhlsp		; Ausgabe HL + Space
		call	bin_e		; Ausgabe E binr
		call	out_crlf
		ld	b, d
		pop	de
kdo_j2:		ld	(hl), b
		call	nextadr1
		jr	kdo_j1

;------------------------------------------------------------------------------
; M   Transport eines Speicherbereiches
;     auf einen anderen Speicherbereich
;       M anfadr_endadr_zieladr
;------------------------------------------------------------------------------

move:		call	threeparams
move1:		ld	a, (hl)
		ld	(bc), a
		inc	bc
		call	nextadr1
		jr	move1

;------------------------------------------------------------------------------
; R   Einlesen eines INTEL-Hex-Files
;     ueber den Reader-Kanal
;       R
;------------------------------------------------------------------------------

read:		call	param
		ld	a, b
		sub	0Dh
		ld	b, a
		ld	c, a
		pop	de
		jr	z, read1
		call	param		; 1 Parameter holen
		pop	bc
read1:		ex	de, hl
		exx
		call	out_crlf
read2:		call	readd7		; Zeicheneingabe 7 Bit
		sub	3Ah ; ':'
		ld	b, a
		and	0FEh ; ''
		jr	nz, read2
		ld	d, a
		call	read_2ziff	; Eingabe 2 Hexziffern -> A, aufsummieren auf D
		ld	e, a
		call	read_2ziff	; Eingabe 2 Hexziffern -> A, aufsummieren auf D
		push	af
		call	read_2ziff	; Eingabe 2 Hexziffern -> A, aufsummieren auf D
		exx
		pop	de
		ld	e, a
		push	bc
		push	de
		push	hl
		add	hl, de
		ex	(sp), hl
		pop	ix
		exx
		pop	hl
		call	read_2ziff	; Eingabe 2 Hexziffern -> A, aufsummieren auf D
		dec	a
		ld	a, b
		pop	bc
		jr	nz, read3
		add	hl, bc
		add	ix, bc
read3:		inc	e
		dec	e
		jr	z, read7
		dec	a
		jr	z, read8
read4:		call	read_2ziff	; Eingabe 2 Hexziffern -> A, aufsummieren auf D
		call	read14
		jr	nz, read4
read5:		call	read_2ziff	; Eingabe 2 Hexziffern -> A, aufsummieren auf D
		jr	z, read2
read6:		push	ix
		pop	hl
		call	outhl
		jp	error
;
read7:		ld	a, h
		or	l
		ret	z
		ex	de, hl
		ld	hl, 34h	; '4'
		add	hl, sp
		ld	(hl), d
		dec	hl
		ld	(hl), e
		ret
;
read8:		ld	l, 1
read9:		call	read12
		jr	c, read11
read10:		call	read14
		jr	nz, read9
		jr	read5
;
read11:		ld	c, a
		call	read12
		ld	b, a
		exx
		push	bc
		exx
		ex	(sp), hl
		add	hl, bc
		ld	a, l
		call	read14
		ld	a, h
		pop	hl
		jr	read10
;
read12:		dec	l
		jr	nz, read13
		call	read_2ziff	; Eingabe 2 Hexziffern -> A, aufsummieren auf D
		dec	e
		ld	h, a
		ld	l, 8
read13:		call	read_2ziff	; Eingabe 2 Hexziffern -> A, aufsummieren auf D
		sla	h
		ret

; Eingabe 2 Hexziffern -> A, aufsummieren auf D
read_2ziff:	push	bc
		call	read_ziff
		rlca
		rlca
		rlca
		rlca
		ld	c, a
		call	read_ziff
		or	c
		ld	c, a
		add	a, d
		ld	d, a
		ld	a, c
		pop	bc
		ret
;
read14:		ld	(ix+0),	a
		cp	(ix+0)
		jr	nz, read6
		inc	ix
		dec	e
		ret

;------------------------------------------------------------------------------
; S (Substitute):	Modifizieren von Speicherzellen. Mit der
; 			Leertaste kann zur nchsten Adresse weiter-
; 			geschaltet werden. Mit >ENTER< wird das
; 			Kommando beendet.
; 
; 			S<anfadr>(_^)
;------------------------------------------------------------------------------


Substitute:	call	param
		pop	hl		; anfadr

Substitute1:	ld	a, (hl)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		call	outminus	; Ausgabe '-'-Zeichen, nchstes Zeichen lesen
		ret	c		; bei <ENTER>
		jr	z, Substitute2
		cp	5Fh ; '_'
		jr	z, Substitute4
		push	hl
		call	param1		; 1 Parameter holen; das aktuelle Zeichen gehrt schon zum Parameter
		pop	de
		pop	hl
		ld	(hl), e
		ld	a, b
		cp	0Dh
		ret	z
;
Substitute2:	inc	hl
Substitute3:	ld	a, l
		and	3
		call	z, outnlhlsp	; Ausgabe CR,LF, HL hexa 4 Stellen, SP
		jr	Substitute1
Substitute4:	dec	hl
		jr	Substitute3

;------------------------------------------------------------------------------
; T (Type):		Ausgabe	eines Speicherbereiches	in ASCII-
; 			Darstellung (falls mglich, sonst .).
; 
; 			T<anfadr>_[<endeadr>](_^)
;------------------------------------------------------------------------------

Type:		call	twoparams
Type1:		call	outnlhlsp	; Ausgabe CR,LF, HL hexa 4 Stellen, SP
		ld	b, 20h
		call	type3
		ret	c
		jr	Type1
;
type3:		ld	a, (hl)
		and	7Fh
		cp	20h ; ' '
		jr	nc, type4
		ld	a, '.'
type4:		ld	c, a
		call	zm_conso	; Zeichenausgabe
		call	nextadr1
		djnz	type3
		ret


;------------------------------------------------------------------------------
; Y:			Suchen nach einer Zeichenfolge von max.	255
; 			Bytes.
; 
; 			Y<byte>[_<byte>][...]^
;------------------------------------------------------------------------------

kdo_y:		ld	d, 0
kdo_y1:		call	param		; 1 Parameter holen
		pop	hl
		ld	h, l
		push	hl
		inc	sp
		inc	d
		ld	a, b
		sub	0Dh
		jr	nz, kdo_y1
		ld	b, a
		ld	c, a
		ld	h, a
		ld	l, d
		dec	l
		add	hl, sp
		push	hl
		push	bc
kdo_y2:		push	bc
		call	out_crlf
		pop	bc
kdo_y3:		pop	hl
		pop	ix
		ld	e, d
		ld	a, (ix+0)
		cpir
		jp	po, kdo_y6
		push	ix
		push	hl
kdo_y4:		dec	e
		jr	z, kdo_y5
		ld	a, (ix-1)
		cp	(hl)
		jr	nz, kdo_y3
		inc	hl
		dec	ix
		jr	kdo_y4
kdo_y5:		pop	hl
		push	hl
		dec	hl
		push	bc
		call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen
		pop	bc
		jr	kdo_y2
kdo_y6:		inc	sp
		dec	e
		jr	nz, kdo_y6
		ret
		
;------------------------------------------------------------------------------
; P (Punch):		Ausgabe	eines Speicherbereiches	in INTEL-
; 			Hex-Format auf den Punch-Kanal.
; 
; 			P<anfadr>_<endeadr>(_^)(<startadr> bei AP=T)
;------------------------------------------------------------------------------

punch:		call	twoparams
punch1:		call	pun_crlf
		ld	bc, 3Ah	; ':'
		call	zm_puno
		push	de
		push	hl

punch2:		inc	b
		call	nextadr		; incl HL, HL=0	oder HL=DE?
		jr	c, punch5
		ld	a, 18h
		sub	b
		jr	nz, punch2
		pop	hl
		call	punch3
		pop	de
		jr	punch1
;
punch3:		ld	d, a
		ld	a, b
		call	punch_a		; Ausgabe A auf	PUNCH
		call	punch_hl	; Ausgabe HL auf Punch
		xor	a
		call	punch_a		; Ausgabe A auf	PUNCH
punch4:		ld	a, (hl)
		call	punch_a		; Ausgabe A auf	PUNCH
		inc	hl
		djnz	punch4
		xor	a
		sub	d
		jp	punch_a		; Ausgabe A auf	PUNCH
;
punch5:		pop	hl
		pop	de
		xor	a
		jr	punch3

;------------------------------------------------------------------------------
; X:			Ausgabe	des Z80-Registersatzes
; 
; 			X^	Ausgabe	des 1. Registersatzes
; 			X'^     Ausgabe des 2. Registersatzes
; 			X[']<reg.> Ausgabe und nderungsmglich-
; 				   keit	fr Register <reg.>
;------------------------------------------------------------------------------

kdo_x:		call	zm_char		; Eingabe Buchstabe oder ENTER
		ld	hl, tab_reg
		cp	0Dh		; <Enter>?
		jr	z, kdo_x7	; Register anzeigen
		cp	27h ; '''       ; zweiter Registersatz?
		jr	nz, kdo_x1
		ld	hl, tab_reg2
		call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	0Dh		; <Enter>?
		jr	z, kdo_x7	; Register anzeigen

; Register ndern
kdo_x1:		cp	(hl)		; Registernamen vergleichen
		jr	z, kdo_x2	; wenn gefunden
		bit	7, (hl)		; Tabellenende?
		jp	nz, error	; dann, Fehler
		inc	hl		; zum nchsten Registernamen
		inc	hl
		jr	kdo_x1

kdo_x2:		call	outsp		; Leerzeichen ausgeben
kdo_x3:		inc	hl		; in Registertabelle
		ld	a, (hl)		; Offset fr Registerwert
		ld	b, a
		and	3Fh ; '?'	; obere Bits ausblenden
		ex	de, hl
		ld	l, a
		ld	h, 0
		add	hl, sp
		ex	de, hl
		inc	hl
		ld	a, (de)		; Wert holen
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		bit	7, b
		jr	z, kdo_x4
		dec	de
		ld	a, (de)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
kdo_x4:		call	outminus	; Ausgabe '-'-Zeichen, nchstes Zeichen lesen
		ret	c
		jr	z, kdo_x6
		push	hl
		push	bc
		call	param1		; 1 Parameter holen; das aktuelle Zeichen gehrt schon zum Parameter
		pop	hl
		pop	af
		push	bc
		push	af
		ld	a, l
		ld	(de), a
		pop	bc
		bit	7, b
		jr	z, kdo_x5
		inc	de
		ld	a, h
		ld	(de), a
kdo_x5:		pop	bc
		pop	hl
		ld	a, b
		cp	0Dh
		ret	z
kdo_x6:		bit	7, (hl)
		ret	nz
		jr	kdo_x3

; Register anzeigen
kdo_x7:		call	out_crlf
kdo_x8:		call	outsp		; Leerzeichen ausgeben
		ld	a, (hl)
		inc	hl
		or	a
		ret	m
		ld	c, a
		call	zm_conso	; Zeichenausgabe
		ld	c, '='
		call	zm_conso	; Zeichenausgabe
		ld	a, (hl)
		ld	b, a
		and	3Fh ; '?'
		inc	hl
		ex	de, hl
		ld	l, a
		ld	h, 0
		add	hl, sp
		ex	de, hl
		bit	6, b
		jr	nz, kdo_x10
		ld	a, (de)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		bit	7, b
		jr	z, kdo_x8
		dec	de
		ld	a, (de)
kdo_x9:		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		jr	kdo_x8
kdo_x10:	push	hl
		ld	a, (de)
		ld	h, a
		dec	de
		ld	a, (de)
		ld	l, a
		ld	a, (hl)
		pop	hl
		jr	kdo_x9

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

zmmsg:		ld	hl, aZ9001Monitor3_ ; "\r\n\f\a	Z9001 MONITOR 3.01(CP/M)  FS 1986 "...

;Stringausgabe, HL=String, B=Lnge
zmmsg1:		ld	c, (hl)
		inc	hl
		call	zm_conso	; Zeichenausgabe
		djnz	zmmsg1
		call	zm_csts
		or	a
		ret	z
		call	consid7		; Zeicheneingabe + Lschen 7. Bit
		cp	3		; <STOP> ?
		jr	z, error0	; dann Abbruch
		call	consid7		; Zeicheneingabe + Lschen 7. Bit
		ret
;
error:		ld	c, 7
		call	zm_conso	; Zeichenausgabe
		ld	c, '*'
		call	zm_conso	; Zeichenausgabe
error0:		call	eor
		ld	de, -16h
		add	hl, de
		ld	sp, hl
		jp	prompt

; Zeicheneingabe und Vergleich mit D
readd:		call	zm_readi
		cp	d
		ret
; End of function readd

;------------------------------------------------------------------------------
; Ausgabe der hchsten RAM-Adresse (RAM-TOP)
;------------------------------------------------------------------------------

kdo_z:		call	eor
		ld	bc, tab_reg-regrstor
		add	hl, bc

; Ausgabe CR,LF, HL hexa 4 Stellen, SP
outnlhlsp:	call	out_crlf

; Ausgabe HL + Space
outhlsp:	call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen

; Leerzeichen ausgeben
outsp:		ld	c, 20h ; ' '
		jp	zm_conso	; Zeichenausgabe

;
pun_crlf:	ld	c, 0Dh
		call	zm_puno
		ld	c, 0Ah
		jp	zm_puno


;------------------------------------------------------------------------------
; N (Null): Ausgabe von binren Nullen auf den Punch-Kanal.
; (Lochbandvorschub, sinnlos bei AP=T)
;------------------------------------------------------------------------------

null:		call	punch_init	; Ausgabe 72 Nullen auf	Punch
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

; Konvertierung	low Nibble A in	Hex Ascii
toasc:		and	0Fh
		add	a, 90h ; ''
		daa
		adc	a, 40h ; '@'
		daa
		ld	c, a
		ret

; zwei Parameter holen (HL, DE := DE|HL+003F)
twoparams:	call	params		; C Parameter holen
		pop	de		; parameter 2
		pop	hl		; parameter 1
		push	hl
		ld	a, d		; paramter 2 = 0?
		or	e
		jr	nz, twopar1	; nein
		ld	de, 3Fh	; '?'   ; ja: 003F zum 1. Parameter addieren
		add	hl, de
		ex	de, hl
twopar1:	pop	hl


; CR+LF ausgeben
out_crlf:	push	hl
		ld	b, 2		; Ausgabe der ersten zwei Zeichen der Systemmeldung (CR+LF)
		call	zmmsg
		pop	hl
		ret

; 3 Parameter holen -> HL, DE, BC
threeparams:	inc	c
		call	params		; C Parameter holen 
		call	out_crlf
		pop	bc
		pop	de
		pop	hl
		ret

; 1 Parameter holen
param:		ld	c, 1

; C Parameter holen
params:		ld	hl, 0
params1:	call	zm_char		; Eingabe Buchstabe oder ENTER
params2:	ld	b, a		; Zeichen sichern
		call	test_ziff	; Test auf Ziffer
		jr	c, params3	; Parameter auf	Stack legen
		add	hl, hl		; HL :=	HL*10h
		add	hl, hl
		add	hl, hl
		add	hl, hl
		or	l
		ld	l, a		; neue Ziffer dazuaddieren
		jr	params1
params3:	ex	(sp), hl	; Parameter auf	Stack legen
		push	hl
		ld	a, b		; Zeichen restaurieren
		call	tst_next	; folgt	Leerzeichen, Komma (Z=1) oder Enter (Cy=1)?
		jr	nc, params4
		dec	c
		ret	z
params4:	jp	nz, error
		dec	c
		jr	nz, params
		ret

; 1 Parameter holen; das aktuelle Zeichen gehrt schon zum Parameter
param1:		ld	c, 1
		ld	hl, 0
		jr	params2

;
nextadr1:	call	nextadr		; incl HL, HL=0	oder HL=DE?
		ret	nc
		inc	sp
		inc	sp
		ret

; incl HL, HL=0	oder HL=DE?
nextadr:	inc	hl
		ld	a, h
		or	l
		scf
		ret	z
nextadr0:	ld	a, e
		sub	l
		ld	a, d
		sbc	a, h
		ret

;------------------------------------------------------------------------------
; H   Bildung der Summe und Differenz
;     zweier Hexzahlen
;       H zahl1_zahl2
;------------------------------------------------------------------------------

kdo_h:		call	twoparams
		push	hl
		add	hl, de
		call	outhlsp		; Ausgabe HL + Space
		pop	hl
		or	a
		sbc	hl, de

; Ausgabe HL hexadezimal ASCII 4 Stellen
outhl:		ld	a, h
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		ld	a, l

; Ausgabe A hexadezimal	ASCII 2	Stellen
outah:		push	af
		rrca
		rrca
		rrca
		rrca
		call	outah1
		pop	af
outah1:		call	toasc		; Hex -> ASCII
		jp	zm_conso	; Zeichenausgabe


;------------------------------------------------------------------------------
; zu Punch
;------------------------------------------------------------------------------

punch_init0:	ld	bc, 8FFh
		jr	puni1

; Ausgabe 72 Nullen auf	Punch
punch_init:	ld	bc, 4800h	; B = 48h, C = 0
puni1:		call	zm_puno
		djnz	puni1
		ret

;
read_ziff:	call	readd7		; Zeicheneingabe 7 Bit

; Test auf Ziffer
test_ziff:	sub	30h ; '0'
		ret	c
		cp	17h
		ccf
		ret	c
		cp	0Ah
		ccf
		ret	nc
		sub	7
		cp	0Ah
		ret

; Ausgabe HL auf PUNCH
punch_hl:	ld	a, h
		call	punch_a		; Ausgabe A auf	PUNCH
		ld	a, l

; Ausgabe A auf	PUNCH
punch_a:	push	af
		rrca
		rrca
		rrca
		rrca
		call	toasc		; Hex -> ASCII
		call	zm_puno
		pop	af
		push	af
		call	toasc		; Hex -> ASCII
		call	zm_puno
		pop	af
		add	a, d
		ld	d, a
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

; Ausgabe '-'-Zeichen, nchstes Zeichen lesen
outminus:	ld	c, 2Dh ; '-'
		call	zm_conso	; Zeichenausgabe

; nchstes Zeichen lesen; Test auf Leerzeichen oder Enter
getch:		call	zm_char		; Eingabe Buchstabe oder ENTER

; folgt	Leerzeichen, Komma (Z=1) oder Enter (Cy=1)?
tst_next:	cp	' '
		ret	z
		cp	','
		ret	z
		cp	0Dh
		scf
		ret	z
		ccf
		ret

; Zeicheneingabe 7 Bit
readd7:		call	readd		; Zeicheneingabe und Vergleich mit D
		and	7Fh ; ''
		ret

;------------------------------------------------------------------------------
; K (Kassette):		Tapelook
;------------------------------------------------------------------------------

kdo_k:		ld	hl, CONBU
		ld	(DMA), hl
		call	requ
		ret	c

kdo_k1:		call	out_crlf

kdo_k2:		call	marek
		call	inita
		push	af
		ld	a, (6Bh)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		pop	af
		ld	c, ' '
		jr	nc, kdo_k3
		ld	c, '?'

kdo_k3:		call	zm_conso	; Zeichenausgabe
		call	outsp		; Leerzeichen ausgeben
		call	stopkey
		ret	c
		ld	a, (6Bh)
		inc	a
		jr	z, kdo_k
		dec	a
		jr	nz, kdo_k2
		ld	hl, kdo_k1
		push	hl
		ld	hl, 80h	; ''
		ld	de, 97h	; ''
kdo_k4:		call	display2
		call	outsp		; Leerzeichen ausgeben
		ld	b, 8
		call	type3
		ret	c
		call	out_crlf
		ld	b, 4
kdo_k5:		call	outsp		; Leerzeichen ausgeben
		djnz	kdo_k5
		jr	kdo_k4

;------------------------------------------------------------------------------
; L (Laden):		Laden von Programmen, die auf Festwert-
; 			speicher vorliegen und der Konventionen
; 			fr das	symbolische Aufrufen von Anwender-
; 			programmen des 0S-Z 9001 entsprechen.
; 
; 			L<name>^
; 			Name: max. 8 Buchstaben	oder Zahlen, wobei
; 			des erste Zeichen ein Buchstabe	sein mu.
;------------------------------------------------------------------------------

kdo_l:		ld	c, 0Ah
		ld	de, CONBU
		ld	a, 28h ; '('
		ld	(de), a
		call	bdos0
		call	coext
		call	gval
		call	cprom
		jp	nz, error
		jp	(hl)

;------------------------------------------------------------------------------
; Kommando U, Umschaltung 20Z/24Z
;------------------------------------------------------------------------------

kdo_u:		in	a, (PIO1AD)	; PIO1 A Daten Beeper, Border, 20Z
		xor	4
		out	(PIO1AD), a	; PIO1 A Daten Beeper, Border, 20Z
		bit	2, a
		ld	h, 21		; letzte zu rollende Zeile + 1 
		jr	nz, kdo_u1
		ld	h, 25		; letzte zu rollende Zeile + 1 
kdo_u1:		ld	l, 0		; 1. rollende Zeile - 1
		ld	(3Bh), hl	; P1ROL+P2ROL
		ret

;------------------------------------------------------------------------------
; TRAP
; wird bei RST 38 ausgefhrt
;------------------------------------------------------------------------------

trap:		push	hl
		push	de
		push	bc
		push	af
		call	eor
		ex	de, hl
		ld	hl, 0Ah
		add	hl, sp
		ld	b, 4
		ex	de, hl
trap1:		dec	hl
		ld	(hl), d
		dec	hl
		ld	(hl), e
		pop	de
		djnz	trap1
		pop	bc
		dec	bc
		ld	sp, hl
		ld	hl, 25h
		add	hl, sp
		ld	a, (hl)
		sub	c
		inc	hl
		jr	nz, trap2
		ld	a, (hl)
		sub	b
		jr	z, trap4
trap2:		inc	hl
		inc	hl
		ld	a, (hl)
		sub	c
		jr	nz, trap3
		inc	hl
		ld	a, (hl)
		sub	b
		jr	z, trap4
trap3:		inc	bc
trap4:		ld	hl, 20h
		add	hl, sp
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
		inc	hl
		ld	(hl), c
		inc	hl
		ld	(hl), b
		push	bc
		ld	c, '$'
		call	zm_conso	; Zeichenausgabe
		pop	hl
		call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen
		ld	hl, 25h
		add	hl, sp
		ld	bc, 200h
trap5:		ld	e, (hl)
		ld	(hl), c
		inc	hl
		ld	d, (hl)
		ld	(hl), c
		inc	hl
		ld	a, e
		or	d
		jr	z, trap6
		ld	a, (hl)
		ld	(de), a
trap6:		inc	hl
		djnz	trap5
		ex	af, af'
		exx
		push	hl
		push	de
		push	bc
		push	af
		push	ix
		push	iy
		ld	a, i
		ld	b, a
		ld	a, r
		ld	c, a
		push	bc
trap7:		jp	prompt		; hier wird auch die Flaganzeige reingepatcht


;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

; Zeicheneingabe + Lschen 7. Bit
consid7:	call	zm_consi
		and	7Fh
		ret

; Eingabe Buchstabe oder ENTER
zm_char:	call	consid7		; Zeicheneingabe + Lschen 7. Bit
		ret	z
		inc	a
		ret	m
		dec	a
		cp	0Dh
		ret	z
		push	bc
		ld	c, a
		call	zm_conso	; Zeichenausgabe
		ld	a, c
		pop	bc
		cp	40h ; '@'
		ret	c
		cp	7Bh ; '{'
		ret	nc
		and	5Fh ; '_'
		ret

;------------------------------------------------------------------------------
;  Q   Lesen und Schreiben auf I/O-Ports
;------------------------------------------------------------------------------

kdo_q:		call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	'O'
		jr	z, kdo_qo
		cp	'I'
		jp	nz, error

;Porteingabe
		call	param
		pop	bc
		in	e, (c)

; Ausgabe E binr
bin_e:		ld	b, 8
		call	outsp		; Leerzeichen ausgeben
bin_e1:		sla	e
		ld	a, 18h
		adc	a, a		; 2*18h	(="0') oder 2*18h+1 (="1')
		ld	c, a
		call	zm_conso	; Zeichenausgabe
		djnz	bin_e1
		ret

; Portausgabe
kdo_qo:		call	params
		pop	de
		pop	bc
		out	(c), e
		ret

;------------------------------------------------------------------------------
; V   Vergleich eines Speicherbereiches
;     mit einem anderen
;       V anfadr_endadr_zieladr
;------------------------------------------------------------------------------

kdo_v:		call	threeparams
kdo_v1:		ld	a, (bc)		; Zieladr
		cp	(hl)		; Anfangsadr
		jr	z, kdo_v2	; wenn gleich
		push	bc
;sonst Anzeige der Unterschiede
		call	outmem
		pop	bc
kdo_v2:		inc	bc
		call	nextadr1
		jr	kdo_v1


;------------------------------------------------------------------------------
; Liste der Zuweisungsmglichkeiten fr Assign
;------------------------------------------------------------------------------

tab_asgn:	db 'C'
;
		db 'C'
		db 'V'
		db 'B'
		db 'U'
;
		db 'R'
;
		db 'C'
		db 'P'
		db 'T'
		db 'U'
;
		db 'P'
;
		db 'C'
		db 'P'
		db 'T'
		db 'U'
;
		db 'L'
;
		db 'C'
		db 'V'
		db 'L'
		db 'U'

;------------------------------------------------------------------------------
; Register restaurieren
; s. init2
; Register sichern s. rst38
;------------------------------------------------------------------------------

regrstor:	pop	bc
		ld	a, c
		ld	r, a
		ld	a, b
		ld	i, a
		pop	iy
		pop	ix
		pop	af
		pop	bc
		pop	de
		pop	hl
		ex	af, af'
		exx
		pop	de
		pop	bc
		pop	af
		pop	hl
		ld	sp, hl
		nop
		ld	hl, 0
		jp	0

		db    0
		db    0
		db    0
		db    0
		db    0
		db    0

;------------------------------------------------------------------------------
; Tabellen fr Registeranzeige
;------------------------------------------------------------------------------

tab_reg:	db 'A'
		db  15h			; Stackoffset Register
		db 'B'
		db  13h
		db 'C'
		db  12h
		db 'D'
		db  11h
		db 'E'
		db  10h
		db 'F'
		db  14h
		db 'H'
		db  31h
		db 'L'
		db  30h
		db 'M'
		db 031h+11000000b
		db 'P'
		db 034h+10000000b
		db 'S'
		db  17h+10000000b
		db 'I'
		db    3
		db 0C1h			; bit7=1 Tabellenende
;Schattenregister
tab_reg2:	db 'A'
		db    9
		db 'B'
		db  0Bh
		db 'C'
		db  0Ah
		db 'D'
		db  0Dh
		db 'E'
		db  0Ch
		db 'F'
		db    8
		db 'H'
		db  0Fh
		db 'L'
		db  0Eh
		db 'M'
		db  0Fh+11000000b
		db 'X'
		db  07h+10000000b
		db 'Y'
		db  05h+10000000b
		db 'R'
		db    2
		db 0C1h			; bit7=1 Tabellenende


;------------------------------------------------------------------------------
; Systemaufrufe
;------------------------------------------------------------------------------

zm_consi:	push	bc
		ld	c, 1		; CONSI: Eingabe eines Zeichens von CONST
		jr	syscall1

;
zm_readi:	push	bc
		ld	c, 3		; READI: Eingabe eines Zeichens von READ
		jr	syscall1

; Zeichenausgabe
zm_conso:	ld	a, c
		jp	outa		; Ausgabe A

;
zm_puno:	push	bc
		push	de
		ld	e, c
		ld	c, 4		; PUNO: Ausgabe eines Zeichens zu PUNCH
		jr	syscall2

; wird nicht genutzt
zm_listo:	push	bc
		push	de
		ld	e, c
		ld	c, 5		; LISTO: Ausgabe eines Zeichens zu LIST
		jr	syscall2

;
zm_csts:	push	bc
		ld	c, 11		; CSTS: Abfrage Status CONST

;
syscall1:	push	de
syscall2:	push	hl
		call	5
		pop	hl
		pop	de
		pop	bc
		jp	c, error
		ret

;------------------------------------------------------------------------------
; PUN-Treiber
; Lochband-Stanzer SIF-1000
;------------------------------------------------------------------------------

pun:		ld	a, 01000111b
		out	(CTC1),	a	; System CTC1 Anwenderport
		out	(CTC1),	a	; System CTC1 Anwenderport
		ld	a, 00001111b
		out	(PIO1BS), a	; PIO1 B Kommando Anwenderport
		ld	a, c
		cpl
		set	7, a
		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
		nop
		nop
		res	7, a
		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
pun1:		call	stopkey
		jr	nc, pun3
pun2:		cpl
		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
		ret
;
pun3:		in	a, (CTC1)	; System CTC1 Anwenderport
		cp	01000111b
		jr	z, pun1
		ld	a, 01010111b
		out	(CTC1),	a	; System CTC1 Anwenderport
		out	(CTC1),	a	; System CTC1 Anwenderport
		ld	a, 0FFh
		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
pun4:		call	stopkey
		jr	c, pun2
		in	a, (CTC1)	; System CTC1 Anwenderport
		cp	01010111b
		jr	z, pun4
		or	a
		ret
;
stopkey:	ld	a, (KEYBU)
		sub	3
		or	a
		ret	nz
		ld	(KEYBU), a
		scf
		ret

;------------------------------------------------------------------------------
; RDR-Treiber
; Lochband-Leser SIF-1000
;------------------------------------------------------------------------------

rdr:		ld	a, 01000111b
		out	(CTC1),	a	; System CTC1 Anwenderport
		out	(CTC1),	a	; System CTC1 Anwenderport
		ld	a, 11001111b
		out	(PIO1BS), a	; PIO1 B Kommando Anwenderport
		ld	a, 01111111b
		out	(PIO1BS), a	; PIO1 B Kommando Anwenderport
		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
rdr1:		call	stopkey
		jr	c, pun2
		in	a, (CTC1)	; System CTC1 Anwenderport
		cp	01000111b
		jr	z, rdr1
		in	a, (PIO1BD)	; PIO1 B Daten Anwenderport
		cpl
		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
		and	7Fh
		ret

;------------------------------------------------------------------------------
; LST-Treiber fr LIST
; V24-Drucker (TD40)
;------------------------------------------------------------------------------

list:		ld	a, 11001111b
		out	(PIO1BS), a	; PIO1 B Kommando Anwenderport
		ld	a, 11111110b
		out	(PIO1BS), a	; PIO1 B Kommando Anwenderport
list1:		call	stopkey
		jr	nc, list2
		ld	(LISW), a
		ret
;
list2:		in	a, (PIO1BD)	; PIO1 B Daten Anwenderport
		add	a, a
		jr	c, list1
		ld	hl, varlist
		ld	a, 0Dh
		sub	c
		jr	nz, list3
		ld	(hl), a
		jr	list4
list3:		ld	a, 1Fh
		cp	c
		jr	nc, list4
		inc	(hl)
		ld	a, 29h ; ???
		sub	(hl)
		jr	list4
		ld	(hl), a
		ld	a, 0Dh
		call	list5
		ld	a, 0Ah
		call	list5
list4:		ld	a, c
		call	list5
		or	a
		ret
;
list5:		ld	c, 4Ah		; Zeitkonstante 9600 Baud
		ld	b, 9
		and	7Fh
		di
		rla
list6:		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
		call	list7
		rra
		djnz	list6
		cpl
		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
		ei
;
list7:		push	bc
		ld	b, c
list8:		djnz	list8
		pop	bc
		ret

;------------------------------------------------------------------------------
; UR1-Treiber
;------------------------------------------------------------------------------

ur1:		ld	a, 0FFh
		ld	(PSUM), a
		exx
		ld	(var1), hl
		exx
		jr	ur12
;
ur11:		xor	a		; UP1-Treiber fr PUNCH
		ld	(PSUM), a
ur12:		ld	sp, (0Bh)
		pop	hl
		pop	hl
		pop	de
		ld	(AADR), hl
		ld	(EADR), de
		call	eor
		ld	de, -16h
		add	hl, de
		ld	sp, hl
		ld	hl, prompt
		push	hl
		ld	a, (PSUM)
		or	a
		jr	nz, ur14
		ld	bc, 100Bh	; B=10h, C=0Bh 
		call	zm_conso	; Zeichenausgabe
		ld	c, 9
ur13:		call	zm_conso	; Zeichenausgabe
		djnz	ur13
		call	param
		pop	hl
		ld	(SADR), hl
		call	out_crlf
ur14:		ld	hl, error
		push	hl

;------------------------------------------------------------------------------
;Kassetten-Ein/-Ausgabe
;	Mit dieser Funktion sind Speicherbereiche als
;	Files von/auf Kassette lad-/entladbar.
;
;	Eintrittsparameter:
;	(69H)	: =0 Aus-, sonst Eingabe
;	(58H)	: Verschiebung bei Eingabe
;	(6DH)	: Anfangsadr. fr Ausgabe
;	(6FH)	: Endeadr. fr Ausgabe
;	(71H)	: Startadr.
;------------------------------------------------------------------------------

cass:		ld	de, aFilename	; "Filename:"
		call	bd_prnst
		ld	de, FNAME-1
		call	getfn		; Get Filename
		ld	a, (PSUM)
		or	a
		jr	nz, cload
		ld	a, (FNAME)
		cp	' '
		ret	z
		call	cass1		; Filenamen Leerzeichen	-> 00
		ld	hl, varcass
		ld	b, (hl)
		ld	(hl), 0FFh
		push	bc
		call	csave
		pop	bc
		ld	a, b
		ld	(varcass), a
		ret	c
		pop	hl
		ret

; Filenamen Leerzeichen	-> 00
cass1:		ld	b, 11
		ld	hl, FNAME
cass2:		ld	a, (hl)
		cp	' '
		jr	nz, cass3
		ld	(hl), 0
cass3:		inc	hl
		djnz	cass2
		ret

aFilename:	db "Filename:",0

; Laden
cload:		ld	hl, CONBU	; CCP-Eingabepuffer und	Standardpuffer fr Kassetten-E/A
		ld	(DMA), hl
cload1:		call	openr		; Open fr Kassette lesen
		jr	nc, cload3
		or	a
		scf
		ret	z
		cp	0Dh
		jr	nz, cload2
		ld	b, a
		ld	a, (FNAME)
		cp	' '
		jr	z, cload3
		ld	a, b
cload2:		scf
		call	rea		; Ausgabe Fehlermeldung; warten	auf Bedienerreaktion
		jr	cload1
;
cload3:		ld	hl, CONBU
		call	dspfn		; Filename anzeigen
		ld	a, (CONBU)
		cp	' '
		ld	hl, 100h	; Anfangsadresse bei CP/M
		jr	c, cload4
		ld	de, (58h)
		ld	hl, (AADR)
		add	hl, de
		call	outhlsp
		ld	hl, (EADR)
		add	hl, de
		call	outhlsp
		ld	hl, (SADR)
		call	outhlsp
		ld	hl, (AADR)
		ld	de, (58h)
		add	hl, de
cload4:		ld	(DMA), hl
		call	loa55		; LESEN BLOCK
		ret	c
		pop	hl
		ld	hl, (SADR)
		jp	read7


; Speichern
csave:		ld	hl, (EADR)
		ld	de, (AADR)
		or	a
		sbc	hl, de
		jp	c, erinp
		ld	hl, nokey
		push	hl
		call	bd_openw
		ret	c
		ex	de, hl
		ld	(DMA), hl
csave1:		ld	hl, (DMA)
		ld	de, 7Fh
		add	hl, de
		ld	de, (EADR)
		sbc	hl, de
		jr	nc, csave2
		call	bd_writs
		ld	(varsav), a
		ret	c
		call	outblnr		; Blocknummer anzeigen
		ret	c
		jr	csave1
csave2:		call	bd_closw
		ret	c
		ld	hl, varsav
		inc	(hl)
		ld	de, aVrfyN	; "\n\rVrfy? N\b"
		call	bd_prnst
		call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	'Y'
		scf
		ccf
		ret	nz
; Verify
		ld	de, aRewind	; " <="
		call	bd_prnst
		call	getms		; Eingabe Zeichenkette in CONBU
		ret	c
csave3:		ld	hl, CONBU
		ld	(DMA), hl
		call	bd_openr
		jr	c, csave4
		call	stopkey
		jr	nc, csave7
		ret
;
csave4:		or	a
		ret	z
		call	rea1		; Ausgabe Fehlermeldung; warten	auf Bedienerreaktion
		ret	c
		jr	csave3
;
csave5:		call	bd_reads
		jr	nc, csave6
		call	rea1		; Ausgabe Fehlermeldung; warten	auf Bedienerreaktion
		ret	c
		jr	csave5
;
csave6:		ld	l, a
		call	stopkey
		ret	c
		ld	a, l
csave7:		ld	hl, CONBU
		ld	(DMA), hl
		or	a
		jr	z, csave5
		ret

aVrfyN:		db 0Ah
		db 0Dh,"Vrfy? N",8,0
aRewind:	db " <=",0

;------------------------------------------------------------------------------
; BDOS-Aufrufe OS bzw. CCP
;------------------------------------------------------------------------------

bd_openw:	ld	c, 15
		jr	bdos00

bd_writs:	ld	c, 21
		jr	bdos00

bd_closw:	ld	c, 16
		jr	bdos00

bd_prnst:	ld	c, 9
		jr	bdos00

bd_openr:	ld	c, 13
		jr	bdos00

bd_reads:	ld	c, 20
bdos00:		jp	bdos0

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

; Blocknummer anzeigen
outblnr:	ld	a, (varsav)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		ld	c, 8
		call	zm_conso	; Zeichenausgabe
		call	zm_conso	; Zeichenausgabe
		jp	stopkey


nokey:		ld	a, 0
		ld	(KEYBU), a
		ret

		db    0
		db    0
		db    0

;------------------------------------------------------------------------------
; Kommando E (step):
; vp: Einzelschritt mit Registeranzeige
;------------------------------------------------------------------------------

step:		call	getch
		jr	c, step1
		jr	z, step2
		call	param1		; 1 Parameter holen; das aktuelle Zeichen gehrt schon zum Parameter
		pop	de
		ld	hl, 0034h	; ???
		add	hl, sp
		ld	(hl), d
		dec	hl
		ld	(hl), e
		ld	a, b
		cp	0Dh
step1:		ld	bc, 1
		jr	z, step3
step2:		call	param
		ld	a, b
		pop	bc
		cp	0Dh
		jp	nz, error
step3:		dec	bc
		ld	(eadrcnt), bc	; Parameter von	E (EOF)
		ld	hl, (beg-0009h)	; 0AFF7h
		ld	(curradr), hl	; Speicher fr aktuelle	Adresse
		ld	hl, step4
		ld	(beg-0009h), hl	; 0AFF7h
		ld	hl, trap7+1
		ld	de, dspregs	; alle Register	+ Flags	anzeigen
		ld	(hl), e
		inc	hl
		ld	(hl), d
		pop	de
		pop	bc
		jp	beg-001Dh	;0AFE3h
step4:		push	hl
		ld	hl, (curradr)	; Speicher fr aktuelle	Adresse
		ex	(sp), hl
;
step5:		push	af
		di
		ld	a, 10000111b
		out	(CTC1),	a	; System CTC1 Anwenderport
		ld	a, 00000010b
		out	(CTC1),	a	; System CTC1 Anwenderport
		pop	af
		nop
		nop
		ei
		ret
;
step6:		pop	hl
		push	bc
		ld	bc, (eadrcnt)	; Parameter von	E (EOF)
		ld	a, b
		or	c
		dec	bc
		ld	(eadrcnt), bc	; Parameter von	E (EOF)
		pop	bc
		jr	z, step7
		pop	af
		jp	step5
;
step7:		pop	af
		jp	cmd_rzm
;
; alle Register	+ Flags	anzeigen
dspregs:	ld	hl, tab_reg
		call	kdo_x7		; Register anzeigen
		ld	a, (beg-0028h)	; 0AFD8h
		call	dspflags	; Flags	anzeigen
		ld	hl, tab_reg2
		call	kdo_x7		; Register anzeigen
		ld	a, (beg-0034h)	; 0AFCCh
		call	dspflags	; Flags	anzeigen
		call	dspcod		; 5 Bytes anzeigen
		ld	hl, prompt
		ld	(trap7+1), hl
		jp	(hl)
		jp	prompt

; Flags	anzeigen
dspflags:	ld	b, 8
		ld	hl, a00000000	; "00000000\n\r"
		push	hl
dspflags1:	ld	(hl), '0'
		rla
		jr	dspflags2

		db    0

;------------------------------------------------------------------------------
; Startbereich fr OS-Kommandos
;------------------------------------------------------------------------------

		org nextpage($)

jp_cold:	jp	cmd_cold
		db "#       ",0
		jp	cmd_zm
aZm:		db "ZM      ",0
		jp	cmd_rzm
aRzm:		db "RZM     ",0


;
dspflags2:	jr	nc, dspflags3
		ld	(hl), '1'
dspflags3:	inc	hl
		djnz	dspflags1
		ld	de, aFlags	; "\r\nSZ*H*VNC\r\n"
		ld	c, 9
		call	5
		pop	de
		ld	c, 9
		call	5
		ret

; 5 Bytes anzeigen
dspcod:		ld	hl, (beg-0009h)	;0AFF7h
		ld	b, 5
dspcod1:	ld	a, (hl)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		inc	hl
		ld	c, 2
		ld	e, ' '
		call	5
		djnz	dspcod1
		ret

; Interrupt-Routine fr	CTC1
isr_ctc1:	push	af
		push	hl
		ld	hl, step6
		push	hl
		ld	a, 3
		out	(CTC1),	a	; System CTC1 Anwenderport
		ei
		reti

;
init:		ld	hl, isr_ctc1	; Interrupt-Routine fr	CTC1
		ld	(202h),	hl
		jp	init1

curradr:	dw unk_F6CD		; Speicher fr aktuelle	Adresse
eadrcnt:	dw 0FFFFh		; Parameter von	E (EOF)

		db 0FFh

;------------------------------------------------------------------------------
; "#       " OS-Erweiterung
;------------------------------------------------------------------------------

cmd_cold:	ld	hl, gocpm	; OS-CCP
		push	hl
cmd_cold1:	ld	de, aEos	; "\vEOS\r\n"
		ld	c, 9
		call	5
;
		ld	de, 0EFC9h
cmd_cold2:	ld	hl, tab_treiber	; Tabelle der Gertetreiber
		ld	bc, 20h		; aEOS-tab_treiber
		ldir
;
		ld	hl, tab_pioinit	; Intialisierungscodes fr PIO (Bit-EA)
		ld	c, 0FAh		; PIO1 (FA, FB)
		call	initpio
		ld	c, 0FEh		; PIO2 (FE, FF)
		ld	hl, tab_pioinit	; Intialisierungscodes fr PIO (Bit-EA)
		call	initpio
		ret

; vp vvvv : ab hier ist unvollstndiger code, der wohl auch nicht genutzt wird ???

		db 0FFh
		db 0FFh
		db 0FFh
byte_BC94:	db 0FFh
		ld	hl, 0D1h ; ''
		ex	(sp), hl
		ld	hl, 0B000h
		ld	bc, 1000h
		ld	de, 0B000h
		di
		exx
		ld	c, 48h ; 'H'
		exx
loc_BCA7:	di
		exx
		push	bc
loc_BCAA:	ld	hl, loc_BCBA
		ld	de, 0A0h ; ''
		ld	bc, 55h	; 'U'
		ldir
		pop	bc
		exx
		jp	0A0h

; wird von obigem Code nach 00A0h kopiert (55h bytes)
loc_BCBA:	di
		in	a, (40h)
		in	a, (70h)
		exx
		in	a, (c)
		exx
		ldir
		in	a, (40h)
		in	a, (78h)
		pop	hl
		ld	a, (hl)
		cpl
		ld	(hl), a
		cp	(hl)
		cpl
		ld	(hl), a
		jr	nz, loc_BCE5
		ex	de, hl
		ld	hl, 0D1h ; ''
		sbc	hl, de
		ex	de, hl
		jr	nz, loc_BCE9
		ex	de, hl
		ld	hl, cmd_zm
		ld	a, 0C3h	; ''
		cp	(hl)
		ex	de, hl
		jr	z, loc_BCE9
loc_BCE5:	exx
		in	a, (c)
		exx
loc_BCE9:	ei
		jp	(hl)
		ld	a, (begdat+1)
		add	a, 0Ch
		ld	(jp_cold+2), a
		ld	(loc_BCAA+2), a
		inc	a
		ld	(cmd_cold1+2), a
		ld	(cmd_cold2+2), a
		ld	a, 0C9h	; ''
		ld	(byte_BC94), a
		call	kdo_z
		dec	h
		ld	(36h), hl
		call	out_crlf
		jp	gocpm
; Ende A0-Bereich

		ld	hl, 0C000h
		ld	de, 0C000h
		ld	bc, 2800h
		push	de
		exx
		ld	c, 48h ; 'H'
		exx
		jp	loc_BCA7
		call	kdo_i1
		ld	hl, 15E4h
		push	hl
		ld	hl, 0C000h
		ld	de, 100h
		ld	bc, 1500h
		exx
		ld	c, 48h ; 'H'
		exx
		jp	loc_BCA7
		ld	hl, 8000h
		ld	de, 0A000h
		push	de
		ld	bc, 600h
		exx
		ld	c, 48h ; 'H'
		exx
		jp	loc_BCA7
		ld	hl, 8600h
		ld	de, 318h
		ld	bc, 1400h
		exx
		ld	c, 48h ; 'H'
		exx
		jp	loc_BCA7
		ld	hl, 8A00h
		ld	de, 0A5A0h
		ld	bc, 190h
		exx
		ld	c, 48h ; 'H'
		exx
		jp	loc_BCA7

; vp ^^^^ code ende


; PIOs initialisieren
initpio:	outi
		outi
		inc	c
		outi
		outi
		ret

; Intialisierungscodes fr PIO (Bit-EA)
tab_pioinit:	dw 11001111b
		dw 11001111b

;------------------------------------------------------------------------------
; Tabelle der Gertetreiber
;------------------------------------------------------------------------------

tab_treiber:	dw const	; TTY-Treiber fr CONST
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
		dw bat		; BAT: STEUERPROGRAMM FUER BATCH-MODE VON CONST
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
;
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
		dw rdr		; RDR-Treiber fr READER
		dw ur1		; UR1-Treiber fr READER
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
;
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
		dw pun		; PUN-Treiber fr PUNCH
		dw ur11		; UP1-Treiber fr PUNCH
		dw list		; UP2-Treiber fr PUNCH
;
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
		dw list		; LST-Treiber fr LIST
		dw pun		; UL-Treiber fr LIST


; EOS-Systemmeldung
aEos:		db 0Bh,"EOS",0Dh,0Ah,0

;------------------------------------------------------------------------------
; TTY-Treiber fr CONST (wie OS, aber mit Tastaturklick)
;------------------------------------------------------------------------------

const:		call	crt
		push	af
		ld	a, (PU)		; Hilfszelle (aufgerufene Treiberfunktion ?)	
		dec	a
		call	z, beep		; wenn PU=1, d.h. Funktion "Eingabe Zeichen"
		pop	af
		ret

; kurzen Ton ausgeben (Tastaturklick)
beep:		push	bc
		ld	b, 0
		ld	c, 14h
		ld	a, 00000111b
		out	(CTC0),	a	; System CTC0 Kassette,	Beeper
		ld	a, 10010110b
		out	(CTC0),	a	; System CTC0 Kassette,	Beeper
		in	a, (PIO1AD)
		set	7, a		; Beeper ein
		out	(PIO1AD), a	; PIO1 A Daten Beeper, Border, 20Z
;
beep1:		djnz	beep1
		dec	c
		jr	nz, beep1
		res	7, a		; Beeper aus
		out	(PIO1AD), a	; PIO1 A Daten Beeper, Border, 20Z
		ld	a, 00000011b
		out	(CTC0),	a	; System CTC0 Kassette,	Beeper
		pop	bc
		ret

;------------------------------------------------------------------------------
; CP/M-BDOS
;------------------------------------------------------------------------------

bdos0:		scf
		ccf
		jr	bdos1
;
bdos:		scf			; BDOS-Sprungverteiler
bdos1:		push	af
		ld	a, i
		cp	2		; OS-Mode ?
		jr	nz, bdos2	; nein -> CP/M-Mode
		pop	af
		jp	bos		; Eintritt OS-BOS
;
bdos2:		push	hl
		ld	h, a		; A = 7Eh
		ld	l, 60h ; '`'
		ld	(0Dh), hl
		pop	hl
		pop	af
		ld	(0Bh), sp
		ld	sp, (0Dh)
		jp	nc, unk_F31B
		ccf
		push	hl
		push	de
		push	af
		push	bc
		ld	(0Dh), bc
		ld	(0Fh), a
		ld	hl, bdos_os	; Systemrufe, die direkt ins Z9001-OS gehen
		ld	a, c
		ld	bc, 11		; Anzahl
		cpir			; suchen
		pop	bc
		jp	z, unk_F327	; wenn gefunden, dann in OS-BOS-Systemrufverteiler
;
		ld	hl, bose	; BOSE:	AUSGANG	AUS BOS
		push	hl
		ld	b, 0
		ld	a, 33		; groesste unterstuetzte BDOS-Funktion
		cp	c
		jp	c, boser	; BOSER
		ld	hl, bdos_zm	; ADRESSTABELLE	DER SYSTEMRUFE
		jp	unk_F336	; in BOS-Systemrufverteiler

; Systemrufe, die direkt ins Z9001-OS gehen
bdos_os:	db    1			; BDOS function	1 (C_READ) - Console input
		db    2			; BDOS function	2 (C_WRITE) - Console output
		db    3			; BDOS function	3 (A_READ) - Auxiliary (Reader)	input
		db    4			; BDOS function	4 (A_WRITE) - Auxiliary	(Punch)	output
		db    5			; BDOS function	5 (L_WRITE) - Printer output
		db    7			; BDOS function	7 - Get	I/O byte
		db    8			; BDOS function	8 - Set	I/O byte
		db 10			; BDOS function	10 (C_READSTR) - Buffered console input
		db 11			; BDOS function	11 (C_STAT) - Console status
		db 12			; BDOS function	12 (S_BDOSVER) - Return	version	number
		db 26

; Sprungverteiler BDOS (CP/M)
bdos_zm:	dw bd_reset		; BDOS function	0 (P_TERMCPM) -	System Reset
		dw bdos_err		; BDOS function	1 (C_READ) - Console input
		dw bdos_err		; BDOS function	2 (C_WRITE) - Console output
		dw bdos_err		; BDOS function	3 (A_READ) - Auxiliary (Reader)	input
		dw bdos_err		; BDOS function	4 (A_WRITE) - Auxiliary	(Punch)	output
		dw bdos_err		; BDOS function	5 (L_WRITE) - Printer output
		dw bd_rawio		; BDOS function	6 (C_RAWIO) - Direct console I/O
		dw bdos_err		; BDOS function	7 - Get	I/O byte
		dw bdos_err		; BDOS function	8 - Set	I/O byte
		dw bd_writestr		; BDOS function	9 (C_WRITESTR) - Output	string
		dw bdos_err		; BDOS function	10 (C_READSTR) - Buffered console input
		dw bdos_err		; BDOS function	11 (C_STAT) - Console status
		dw bdos_err		; BDOS function	12 (S_BDOSVER) - Return	version	number
		dw bd_drvallreset	; BDOS function	13 (DRV_ALLRESET) - Reset discs
		dw bd_noerr		; BDOS function	14 (DRV_SET) - Select disc
		dw bd_fopen		; BDOS function	15 (F_OPEN) - Open file
		dw bd_fclose		; BDOS function	16 (F_CLOSE) - Close file
		dw bd_noerr		; BDOS function	17 (F_SFIRST) -	search for first
		dw bd_noerr		; BDOS function	18 (F_SNEXT) - search for next
		dw bd_noerr		; BDOS function	19 (F_DELETE) -	delete file
		dw bd_fread		; BDOS function	20 (F_READ) - read next	record
		dw bd_fwrite		; BDOS function	21 (F_WRITE) - write next record
		dw bd_fopen		; BDOS function	22 (F_MAKE) - create file
		dw bd_noerr		; BDOS function	23 (F_RENAME) -	Rename file
		dw bd_drvvec		; BDOS function	24 (DRV_LOGINVEC) - Return bitmap of logged-in drives
		dw bd_currdrv		; BDOS function	25 (DRV_GET) - Return current drive
		dw bdos_err		; BDOS function	26 (F_DMAOFF) -	Set DMA	address
		dw bdos_err		; BDOS function	27 (DRV_ALLOCVEC) - Return address of allocation map
		dw bdos_err		; BDOS function	28 (DRV_SETRO) - Software write-protect	current	disc
		dw bd_drvrovec		; BDOS function	29 (DRV_ROVEC) - Return	bitmap of read-only drives
		dw bdos_err		; BDOS function	30 (F_ATTRIB) -	set file attributes
		dw bdos_err		; BDOS function	31 (DRV_DPB) - get DPB address
		dw bdos_err		; BDOS function	32 (F_USERNUM) - get/set user number
		dw bd_fread		; BDOS function	33 (F_READRAND)	- Random access	read record


; BDOS error
bdos_err:	ld	a, 0FFh
		ld	(0Fh), a
		ret

; BDOS function	0 (P_TERMCPM) -	System Reset
bd_reset:	ld	sp, (0Bh)
		jp	cmd_rzm

; BDOS function	6 (C_RAWIO) - Direct console I/O
bd_rawio:	ld	a, 0FFh
		cp	e
		jp	nz, conso
		call	csts
		or	a
		call	nz, consi
		jp	bd_ret

; Filename anzeigen
dspfn:		ld	b, 11
dspfn1:		ld	a, (hl)
		call	outa		; Ausgabe A
		inc	hl
		djnz	dspfn1
		inc	hl
		call	ospac		; Ausgabe Leerzeichen
		ld	a, (hl)
		jp	outa		; Ausgabe A

; BDOS function	9 (C_WRITESTR) - Output	string
bd_writestr:	ex	de, hl
bd_writestr1:	ld	a, (hl)
		or	a
		ret	z
		cp	'$'
		ret	z
		call	outa
		inc	hl
		jr	bd_writestr1


; BDOS function	13 (DRV_ALLRESET) - Reset discs
bd_drvallreset:	ld	bc, CONBU
		jp	setdm

; BDOS function	22 (F_MAKE) - create file 
bd_fopen:	call	bd_fopen3
		ld	(hl), 0FFh
		ret
;
bd_fopen1:	xor	a
		ld	(0Fh), a
bd_fopen2:	pop	hl
		ld	(DMA), hl
		pop	hl
		ld	a, h
		ld	(varcass), a
		or	a
		ret
;
bd_fopen3:	ld	hl, varcass
		ld	a, (hl)
		ld	(hl), 0FFh
		ld	h, a
		pop	bc
		push	hl
		ld	hl, (DMA)
		push	hl
		ld	hl, bd_fopen1
		push	hl
		push	bc
		ld	hl, 0Dh
		add	hl, de
		ld	a, d
		or	a
		ret	nz
		ld	a, e
		cp	5Ch ; '\'
		ret	nz
		dec	hl
		ret

; BDOS function	16 (F_CLOSE) - Close file
bd_fclose:	call	bd_fopen3
		ld	a, (hl)
		ld	(hl), 0
		cp	'R'
		ret	z
		cp	'W'
		ret	nz
		ld	a, 0FFh
		ld	(6Bh), a
		ld	bc, 0A0h
		ld	(DMA), de
		call	unk_F497
		ret

; BDOS function	20 (F_READ) - read next	record 
bd_fread:	call	bd_fopen3
		ld	a, (hl)
		or	a
		jr	z, bd_fread5
		cp	'R'
		jr	z, bd_fread3
		ld	(hl), 'R'
bd_fread1:	call	starttape	; Anzeige "Start Tape" + Filename
		jr	c, bd_fread5
		xor	a
		ld	(6Ch), a
		call	bd_fread7
		ld	(DMA), hl
		call	reads
		jr	nc, bd_fread2
		call	rea
		jr	c, bd_fread5
		jr	bd_fread1
;
bd_fread2:	call	ocrlf
		call	bd_fread7
		inc	hl
		call	dspfn		; Filename anzeigen
bd_fread3:	call	bd_fread7
		ld	(DMA), hl
		call	reads
		jr	nc, bd_fread4
		call	rea
		jr	c, bd_fread5
		jr	bd_fread3
;
bd_fread4:	or	a
		jr	nz, bd_fread6
		call	bd_fread7
		pop	bc
		pop	de
		push	de
		push	bc
		ld	bc, 80h
		ldir
		ret
;
bd_fread5:	ld	a, 0FFh
		ld	(0Fh), a
bd_fread6:	pop	hl
		jp	bd_fopen2
;
bd_fread7:	ld	a, i
		dec	a
		ld	h, a
		ld	l, 73h 		; HL=7F73h
		ret

; BDOS function	21 (F_WRITE) - write next record
bd_fwrite:	call	bd_fopen3
		ld	a, (hl)
		or	a
		jr	z, bd_fread5
		cp	'W'
		jr	z, bd_fwrite1
		ld	(hl), 'W'
		call	starttape	; Anzeige "Start Tape" + Filename
		jr	c, bd_fread5
		xor	a
		ld	(6Bh), a
		ld	hl, (1Bh)
		push	hl
		ld	(1Bh), de
		ld	bc, 1770h
		call	writ1
		pop	hl
		ld	(1Bh), hl
bd_fwrite1:	call	writs
		ld	c, ' '
		call	conso
		ret

; BDOS function	24 (DRV_LOGINVEC) - Return bitmap of logged-in drives
bd_drvvec:	pop	bc
		pop	af
		pop	de
		pop	hl
		ld	hl, 1		; nur LW "A"
bd_drvvec1:	push	hl
		push	de
		push	af
		push	bc
;
bd_noerr:	xor	a
;
bd_ret:		ld	(0Fh), a
		ret

; BDOS function	25 (DRV_GET) - Return current drive
bd_currdrv:	ld	a, 1
		jr	bd_ret

; BDOS function	29 (DRV_ROVEC) - Return	bitmap of read-only drives
bd_drvrovec:	pop	bc
		pop	af
		pop	de
		pop	hl
		ld	hl, 0		; keins
		jr	bd_drvvec1


; Anzeige "Start Tape" + Filename
starttape:	push	de
		push	de
		ld	de, txtrc	; "Start Tape"
		call	bd_writestr
		pop	hl
		inc	hl
		call	dspfn		; Filename anzeigen
		ld	c, ':'
		call	conso
		call	consi
		push	af
		ld	c, ' '
		call	conso
		pop	af
		pop	de
		cp	3		; <STOP> ?
		scf
		ccf
		ret	nz
		scf
		ret

aFlags:		db 0Dh,0Ah
		db "SZ*H*VNC",0Dh,0Ah,0

a00000000:	db "00000000",0Ah
		db 0Dh,0

; weiter zu CRC
crc5:		call	5
		call	outhl
		pop	bc
		ret
aCrcSdlc:	db 0Ah
		db "CRC (SDLC)=",0

;
		dw 9704h		; ???

		end
