; Zusatzmontitor Z9001 Version 3.02 (mit BITEX)
; 1986 F.Schwarzenberg 8036,Gamigstr.5
; reassembliert: V. Pohlers, 01.2009

; File Name   :	ZM302 BITEX.rom
; Base Address:	0000h Range: C000h - E500h Loaded length: 2500h


		cpu	z80

		include	z9001.inc
		include	os.inc

; Systemspeicher
KEYBU		equ	0025h		; Tastaturpuffer
PU		equ	002Fh		; Hilfszelle
;P1ROL		equ	003Bh		; 1. rollende Zeile - 1
;FCB		equ	005Ch		; Dateiname 8 Zeichen
FNAME		equ	005Ch
;FTYP		equ	0064h		; Dateityp 3 Zeichen
PSUM		equ	0069h		; Pruefsumme eines Datenblockes
;LBLNR		equ	006Ch		; gesuchte Blocknummer bei Lesen
AADR		equ	006Dh		; Dateianfangsadresse
EADR		equ	006Fh		; Dateiendeadresse
SADR		equ	0071h		; Startadresse,	wenn Datei ein Maschinencodeprogramm ist

varcass:	equ	0037h		; Hilfszelle CASS

		org 0C000h

beg:		equ	$

; Sprungverteiler

cmd_zm:		jp	init1
cmd_rzm:	jp	trap
		jp	0F006h
		jp	loc_C04B
		jp	loc_C85A
		jp	0F00Fh
		jp	0F012h
		jp	0F015h
		jp	trap
		jp	trap
		jp	trap
		jp	trap
		jp	0F024h
		jp	0F027h
		jp	0F02Ah
		jp	0F02Dh
		jp	trap
		jp	error
		jp	getdez
		jp	todez
		jp	params
		jp	outah
		jp	bin_e
		jp	cass
		jp	bdos0

loc_C04B:	call	0F009h
		and	7Fh
		ret

begdat:		dw 0C000h
		dw 0CFB3h
		dw 0

;------------------------------------------------------------------------------
; I/O-BYTE
;------------------------------------------------------------------------------

; ABFRAGE I/O-BYTE
GIOBY:		ld	a, (4)		; ABFRAGE I/O-BYTE
		ret

; SETZEN I/O-BYTE
SIOBY:		ld	a, c
		ld	(4), a
		ret


;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

eor0:		push	bc
		ld	hl, 0F000h
		ld	b, 3Ch
eor2:		ld	a, (hl)
		cpl
		ld	(hl), a
		cp	(hl)
		cpl
		ld	(hl), a
		ld	c, 1
		jr	z, eor3
		dec	c
		ld	(0EFF1h), hl
eor3:		call	mod		; ndern logische Speicherkonfiguration
		djnz	eor2
		ld	de, (begdat)
		ld	hl, (0EFF1h)
		call	nextadr0
		jr	nc, eor4
		ex	de, hl
eor4:		dec	hl
		ld	bc, -23h
		add	hl, bc
		pop	bc
		ret

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

aZ9001Monitor3_:db 0Dh,0Ah
		db 0Ch,7," Z9001 MONITOR 3.02  F.S.",0Dh,0Ah,0

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

init1:		ld	a, 0C3h			; "JP", RST 38 (TRAP) initialisieren
		ld	(38h), a
		ld	hl, cmd_rzm
		ld	(39h), hl
		ld	a, 10101000b		; IO-Byte setzen
		ld	(4), a
		ld	a, 0FFh
		ld	(54h), a
		call	eor0
		ld	sp, hl
		ex	de, hl
		ld	bc, tab_reg-regrstor
		ld	hl, regrstor		; Register restaurieren
		ldir
		ex	de, hl
		ld	bc, -6Fh
		add	hl, bc
		push	hl
		ld	bc, -91h
		add	hl, bc
		ld	(36h), hl		; EOR
		ld	hl, 0
		ld	b, 9
init3:		push	hl
		djnz	init3
		ld	a, r
		ld	l, a
		ld	a, i
		ld	h, a
		push	hl
		ld	b, init1-aZ9001Monitor3_	; Lnge der Systemmeldung
		call	zmmsg			; Ausgabe der Systemmeldung
		call	kdo_u

;------------------------------------------------------------------------------
; Hauptschleife
;------------------------------------------------------------------------------

prompt:		ld	de, prompt
		push	de
		call	out_crlf
		ld	c, '='
		call	zm_conso	; Zeichenausgabe
		ld	c, '>'
		call	zm_conso	; Zeichenausgabe
prompt1:	call	zm_char		; Eingabe Buchstabe oder ENTER
		and	7Fh
		jr	z, prompt1
		sub	'A'		; A = 0..19h
		ret	m
		cp	1Ah
		ret	nc
		add	a, a
		ld	hl, kdo_tab
		add	a, l
		ld	l, a
		ld	a, h
		adc	a, 0
		ld	h, a
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a		; HL=Adr. Kommando
		ld	c, 2		; Std. 2 Parameter
		jp	(hl)		; Kommando starten

; Sprungverteiler ZM-Kommandos
kdo_tab:	dw kdo_a
		dw bye
		dw convert
		dw display
		dw error
		dw fill
		dw go
		dw kdo_h
		dw kdo_i
		dw kdo_j
		dw kdo_k
		dw kdo_l
		dw move
		dw error
		dw kdo_o
		dw punch
		dw kdo_q
		dw read
		dw substitute
		dw type
		dw kdo_u
		dw kdo_v
		dw write
		dw kdo_x
		dw kdo_y
		dw kdo_z

;------------------------------------------------------------------------------
; A   Geraetezuweisung
;       C fuer CONSOL
;       R fuer READER
;       P fuer PUNCH
;------------------------------------------------------------------------------

kdo_a:		call	zm_char		; Eingabe Buchstabe oder ENTER
		ld	hl, tab_asgn
		ld	bc, 400h	; B := 4, C := 0
		ld	de, 5
kdo_a1:		cp	(hl)		; Suche	Dest-Gert
		jr	z, kdo_a2
		add	hl, de
		inc	c
		djnz	kdo_a1		; Suche	Dest-Gert
		jr	kdo_a5
kdo_a2:		ld	e, c
kdo_a3:		call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	'='
		jr	nz, kdo_a3
		call	zm_char		; Eingabe Buchstabe oder ENTER
		ld	bc, 400h	; B := 4, C := 0
kdo_a4:		inc	hl
		cp	(hl)
		jr	z, kdo_a6
		inc	c
		djnz	kdo_a4
kdo_a5:		jp	error
;
kdo_a6:		ld	a, 3
		inc	e
kdo_a7:		dec	e
		jr	z, kdo_a8
		sla	c
		sla	c
		rla
		rla
		jr	kdo_a7
kdo_a8:		cpl
		ld	d, a
kdo_a9:		call	getch		; nchstes Zeichen lesen; Test auf Leerzeichen oder Enter
		jr	nc, kdo_a9
		ld	a, (4)
		and	d
		or	c
		ld	c, a
		jp	SIOBY		; SETZEN I/O-BYTE

;------------------------------------------------------------------------------
;  B   Rueckgabe an das OS
;------------------------------------------------------------------------------

bye:		jp	wboot		; Warmstart

;------------------------------------------------------------------------------
;O (Off CP/M):	Die Verarbeitung der BDOS-Rufe erfolgt wieder im Z9001-Mode.
;------------------------------------------------------------------------------

kdo_o:		ld	hl, bos		; Eintritt OS-BOS
		ld	(6), hl
		ld	h, 2
		jr	kdo_i2

;------------------------------------------------------------------------------
;I (Init CP/M):		I[Filename[.typ]]^
;			filename: max. 8 Buchstaben oder Zahlen
;			typ	: max. 3     "	      "	   "
;
;			Dieses Kommando	stellt CP/M-Kompatibilitt
;			fr Anwenderprogramme her. Programme knnen
;			jetzt ab der Anfangsadresse 100H geladen
;			werden (nicht mehr 300H!). Die Verarbeitung
;			der BDOS-Rufe erfolgt wie unter	CP/M blich.
;			Diskettenrufe werden auf Kassette umverlegt!
;			Zustzlich wird	der Standard-FCB (jetzt	ab
;			5CH) mit filename.typ initialisiert.
;------------------------------------------------------------------------------

kdo_i:		ld	de, FCB1	; Dateiname 8 Zeichen
		call	getfn		; Get Filename
kdo_i1:		ld	hl, cmd_rzm
		ld	(1), hl
		call	kdo_z
		dec	h
		ld	l, 6Fh		; ??? woher kommt dieser Wert ???
		ld	(36h), hl	; EOR
		inc	l
		ld	(6), hl		; Call 5 (BDOS)	umhngen
		ld	a, 0C3h		; JMP
		ld	(hl), a
		ld	de, bdos	; Sprung zu BDOS-Verteiler eintragen
		inc	l
		ld	(hl), e
		inc	l
		ld	(hl), d
		inc	h
;
kdo_i2:		ld	a, i
		cp	h
		ret	z
;
		di
		ld	a, h
		ld	i, a		; I-Register umhngen
		ld	l, 0
		ex	de, hl
		ld	hl, 3
		add	hl, sp
		ld	(hl), d
		ld	hl, intv	; Interruptadresstabelle 
		ld	bc, 12		; kopieren
		ldir
		ei
		ret

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

; Get Filename
getfn:		exx
		call	getms
		ret	c
		call	coext
		jr	nc, getfn1
		exx
		xor	a
		ld	(de), a
		inc	de
		ld	b, 11
		call	getfn6
		ld	hl, 5
		add	hl, de
		ex	de, hl
		xor	a
		ld	(de), a
		ld	b, 11
		jr	getfn6
;
getfn1:		exx
		ld	hl, CONBU+1
		ld	a, (hl)
		inc	a
		dec	l
		ld	(hl), a
		inc	l
		ld	(hl), ' '
		inc	l
		call	getfn3
		or	a
		jr	nz, getfn2
		ld	a, ' '
		ld	hl, 5
		add	hl, de
		ld	(hl), a
		ret
;
getfn2:		inc	hl
		ld	de, fcb2
;
getfn3:		xor	a
		ld	(de), a
		inc	de
		ld	b, 8
		call	getfn4
		call	nc, getfn6
		cp	'.'
		ld	b, 3
		jr	nz, getfn6
		inc	hl
		call	getfn4
		ret	c
		jr	getfn6
;
getfn4:		ld	a, (hl)
		or	a
		ret	z
		call	getfn5		; Test auf Trennzeichen
		ret	z
		ld	(de), a
		inc	de
		inc	hl
		djnz	getfn4
		ld	a, (hl)
		scf
		ret

; Test auf Trennzeichen
getfn5:		exx
		ld	hl, dtab	; Tabelle der Trennzeichen
		ld	bc, 5
		cpir
		exx
		ret
;
getfn6:		push	af
		ld	a, ' '
getfn7:		ld	(de), a
		inc	de
		djnz	getfn7
		pop	af
		or	a
		ret

;------------------------------------------------------------------------------
; Schreiben von ASCII-Zeichen in den
;      Speicher
;        W anfadr
;------------------------------------------------------------------------------

write:		call	param		; Schreiben von	ASCII-Zeichen in den Speicher
		call	out_crlf
		pop	hl
write1:		call	consid7		; Zeicheneingabe, 7 Bit
		cp	3		; <STOP> ?
		jp	z, outnlhlsp	; Ausgabe CR,LF, HL hexa 4 Stellen, SP
		cp	8		; <Backspace> ?
		jr	z, write3
		ld	(hl), a		; Zeichen in Speicher schreiben
		ld	c, a
		inc	hl		; nchste Adresse
write2:		call	zm_conso	; Zeichenausgabe
		jr	write1
write3:		dec	hl
		ld	c, a
		jr	write2

;------------------------------------------------------------------------------
; C (Convert)  Umrechnung Dezimalzahl in Hexa-
;     dezimalzahl und umgekehrt
;       CD (dez. z.) Dez. = > Hex.
;       CH (hex. z.) Hex. = > Dez.
;------------------------------------------------------------------------------

convert:	call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	'D'
		jr	nz, convert1
		ld	hl, error
		push	hl
;
getdez:		ld	hl, 0
getdez1:	call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	30h ; '0'
		jr	c, getdez2
		cp	3Ah ; ':'
		jr	nc, getdez2
		sub	30h ; '0'
		ld	d, h
		ld	e, l
		add	hl, hl
		ret	c
		add	hl, hl
		ret	c
		add	hl, de
		ret	c
		add	hl, hl
		ret	c
		ld	d, 0
		ld	e, a
		add	hl, de
		ret	c
		jr	getdez1
;
getdez2:	pop	de
		call	outsp		; Leerzeichen ausgeben
		call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen
		ld	c, 'H'
		jp	zm_conso	; Zeichenausgabe
;
convert1:	call	param
		pop	hl
;
todez:		ld	b, 10h
		ld	de, 0
		ld	c, e
todez1:		add	hl, hl
		ld	a, e
		adc	a, e
		daa
		ld	e, a
		ld	a, d
		adc	a, d
		daa
		ld	d, a
		ld	a, c
		adc	a, c
		ld	c, a
		djnz	todez1
		ld	b, c
		call	outsp		; Leerzeichen ausgeben
		ld	a, b
		or	a
		jr	z, todez2
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
todez2:		ex	de, hl
		call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen
		ld	c, 'D'
		jp	zm_conso	; Zeichenausgabe

;------------------------------------------------------------------------------
; zu kdo_v
;------------------------------------------------------------------------------

; Anzeige HL, (HL), A
outmem:		ld	b, a
		call	outhlsp
		ld	a, (hl)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		call	outsp		; Leerzeichen ausgeben
		ld	a, b
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		jp	out_crlf

;------------------------------------------------------------------------------
; D (Display) Ausgabe von Speicherbereichen
;     auf Konsole  (in Hex- und ASCII (ab Vers.3)-Integration)
;       D anfadr_endadr
;------------------------------------------------------------------------------

display:	call	twoparams
display1:	call	outnlhlsp	; Ausgabe CR,LF, HL hexa 4 Stellen, SP
		call	display2
		ld	a, l
		and	7
		ld	b, a
		ld	a, 8
		sub	b
		ld	b, a
		call	outsp		; Leerzeichen ausgeben
		call	type3
		ret	c
		jr	display1
;
display2:	push	hl
display3:	call	outsp		; Leerzeichen ausgeben
		ld	a, (hl)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		inc	hl
		ld	a, l
		and	7
		jr	nz, display3
		pop	hl
		ret

;vvvvv unknown
		call	param
		call	pun_crlf
		ld	c, 3Ah
		call	zm_puno
		xor	a
		call	punch_a
		pop	hl
		call	punch_hl
		ld	hl, 0
		call	punch_hl
		ld	a, 1Ah
		call	punch_a
		jp	null
;^^^^^

;------------------------------------------------------------------------------
; F   Beschreiben eines Speicherbe-
;     reiches mit konst. Wert
;       F anfadr_endadr_wert
;------------------------------------------------------------------------------

fill:		call	threeparams
fill1:		ld	(hl), c
		call	nextadr		; incl HL, HL=0	oder HL=DE?
		jr	nc, fill1
		pop	de
		jp	prompt

;------------------------------------------------------------------------------
; G (Go): Start eines Anwenderprogrammes mit max.
; 	zwei. Haltepunkten.
; 
; 	G<startadr>[_<break1>][_<break2>](_^)
;------------------------------------------------------------------------------

go:		call	getch
		jr	c, go5
		jr	z, go1
		call	param1		; 1 Parameter holen; das aktuelle Zeichen gehrt schon zum Parameter
		pop	de
		ld	hl, 34h		; ???
		add	hl, sp
		ld	(hl), d
		dec	hl
		ld	(hl), e
		ld	a, b
		cp	0Dh
		jr	z, go5
go1:		ld	d, 2
		ld	hl, 35h		; ???
		add	hl, sp
go2:		push	hl
		call	param		; 1 Parameter holen
		ld	e, b
		pop	bc
		pop	hl
		ld	a, b
		or	c
		jr	z, go3
		ld	(hl), c
		inc	hl
		ld	(hl), b
		inc	hl
		ld	a, (bc)
		ld	(hl), a
		inc	hl
		ld	a, 0FFh
		ld	(bc), a
go3:		ld	a, e
		cp	0Dh
		jr	z, go4
		dec	d
		jr	nz, go2
go4:		ld	a, 0C3h		; JP
		ld	(38h), a	; RST38 (TRAP)
		ld	hl, cmd_rzm
		ld	(39h), hl
go5:		call	out_crlf
		pop	de
		ld	hl, 16h		; ???
		add	hl, sp
		jp	(hl)

;------------------------------------------------------------------------------
; J   Nichtzerstoerender Speichertest
;       J anfadr_endadr
;------------------------------------------------------------------------------

kdo_j:		call	twoparams
kdo_j1:		ld	a, (hl)
		ld	b, a
		cpl
		ld	(hl), a
		xor	(hl)
		jr	z, kdo_j2
		push	de
		ld	d, b
		ld	e, a
		call	outhlsp		; Ausgabe HL + Space
		call	bin_e		; Ausgabe E binr
		call	out_crlf
		ld	b, d
		pop	de
kdo_j2:		ld	(hl), b
		call	nextadr1
		jr	kdo_j1

;------------------------------------------------------------------------------
; M   Transport eines Speicherbereiches
;     auf einen anderen Speicherbereich
;       M anfadr_endadr_zieladr
;------------------------------------------------------------------------------

move:		call	threeparams
move1:		ld	a, (hl)
		ld	(bc), a
		inc	bc
		call	nextadr1
		jr	move1

;------------------------------------------------------------------------------
; R   Einlesen eines INTEL-Hex-Files
;     ueber den Reader-Kanal
;       R
;------------------------------------------------------------------------------

read:		call	param
		ld	a, b
		sub	0Dh
		ld	b, a
		ld	c, a
		pop	de
		jr	z, read1
		call	param		; 1 Parameter holen
		pop	bc
read1:		ex	de, hl
		exx
		call	out_crlf
		call	readd7
		jp	error
;
read7:		ld	a, h
		or	l
		ret	z
		ex	de, hl
		ld	hl, 34h
		add	hl, sp
		ld	(hl), d
		dec	hl
		ld	(hl), e
		ret

;------------------------------------------------------------------------------
; S (Substitute):	Modifizieren von Speicherzellen. Mit der
; 			Leertaste kann zur nchsten Adresse weiter-
; 			geschaltet werden. Mit >ENTER< wird das
; 			Kommando beendet.
; 
; 			S<anfadr>(_^)
;------------------------------------------------------------------------------

Substitute:	call	param
		pop	hl		; anfadr
Substitute1:	ld	a, (hl)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		call	outminus	; Ausgabe '-'-Zeichen, nchstes Zeichen lesen
		ret	c		; bei <ENTER>
		jr	z, Substitute2
		cp	5Fh ; '_'
		jr	z, Substitute4
		push	hl
		call	param1		; 1 Parameter holen; das aktuelle Zeichen gehrt schon zum Parameter
		pop	de
		pop	hl
		ld	(hl), e
		ld	a, b
		cp	0Dh
		ret	z
;
Substitute2:	inc	hl
Substitute3:	ld	a, l
		and	3
		call	z, outnlhlsp	; Ausgabe CR,LF, HL hexa 4 Stellen, SP
		jr	Substitute1
Substitute4:	dec	hl
		jr	Substitute3

;------------------------------------------------------------------------------
; T (Type):		Ausgabe	eines Speicherbereiches	in ASCII-
; 			Darstellung (falls mglich, sonst .).
; 
; 			T<anfadr>_[<endeadr>](_^)
;------------------------------------------------------------------------------

Type:		call	twoparams
Type1:		call	outnlhlsp	; Ausgabe CR,LF, HL hexa 4 Stellen, SP
		ld	b, 20h
		call	type3
		ret	c
		jr	Type1
;
type3:		ld	a, (hl)
		cp	' '
		jr	nc, type2
		ld	a, 0DDh
		jr	type4
;
type2:		cp	7Fh
		jr	c, type4
		ld	a, 0D1h
type4:		ld	c, a
		call	zm_conso	; Zeichenausgabe
		call	nextadr1
		djnz	type3
		ret

;------------------------------------------------------------------------------
; Y:			Suchen nach einer Zeichenfolge von max.	255
; 			Bytes.
; 
; 			Y<byte>[_<byte>][...]^
;------------------------------------------------------------------------------

kdo_y:		ld	d, 0
kdo_y1:		call	param		; 1 Parameter holen
		pop	hl
		ld	h, l
		push	hl
		inc	sp
		inc	d
		ld	a, b
		sub	0Dh
		jr	nz, kdo_y1
		ld	b, a
		ld	c, a
		ld	h, a
		ld	l, d
		dec	l
		add	hl, sp
		push	hl
		push	bc
kdo_y2:		push	bc
		call	out_crlf
		pop	bc
kdo_y3:		pop	hl
		pop	ix
		ld	e, d
		ld	a, (ix+0)
		cpir
		jp	po, kdo_y6
		push	ix
		push	hl
kdo_y4:		dec	e
		jr	z, kdo_y5
		ld	a, (ix-1)
		cp	(hl)
		jr	nz, kdo_y3
		inc	hl
		dec	ix
		jr	kdo_y4
kdo_y5:		pop	hl
		push	hl
		dec	hl
		push	bc
		call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen
		pop	bc
		jr	kdo_y2
kdo_y6:		inc	sp
		dec	e
		jr	nz, kdo_y6
		ret

;------------------------------------------------------------------------------
; P (Punch):		Ausgabe	eines Speicherbereiches	in INTEL-
; 			Hex-Format auf den Punch-Kanal.
; 
; 			P<anfadr>_<endeadr>(_^)(<startadr> bei AP=T)
;------------------------------------------------------------------------------

punch:		call	twoparams
		call	pun_crlf
		jp	error

;------------------------------------------------------------------------------
; X:			Ausgabe	des Z80-Registersatzes
; 
; 			X^	Ausgabe	des 1. Registersatzes
; 			X'^     Ausgabe des 2. Registersatzes
; 			X[']<reg.> Ausgabe und nderungsmglich-
; 				   keit	fr Register <reg.>
;------------------------------------------------------------------------------

kdo_x:		call	zm_char		; Eingabe Buchstabe oder ENTER
		ld	hl, tab_reg
		cp	0Dh		; <Enter>?
		jr	z, kdo_x7	; Register anzeigen
		cp	27h ; '''       ; zweiter Registersatz?
		jr	nz, kdo_x1
		ld	hl, tab_reg2
		call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	0Dh		; <Enter>?
		jr	z, kdo_x7	; Register anzeigen

; Register ndern
kdo_x1:		cp	(hl)		; Registernamen vergleichen
		jr	z, kdo_x2	; wenn gefunden
		bit	7, (hl)		; Tabellenende?
		jp	nz, error	; dann, Fehler
		inc	hl		; zum nchsten Registernamen
		inc	hl
		jr	kdo_x1

kdo_x2:		call	outsp		; Leerzeichen ausgeben
kdo_x3:		inc	hl		; in Registertabelle
		ld	a, (hl)		; Offset fr Registerwert
		ld	b, a
		and	3Fh ; '?'	; obere Bits ausblenden
		ex	de, hl
		ld	l, a
		ld	h, 0
		add	hl, sp
		ex	de, hl
		inc	hl
		ld	a, (de)		; Wert holen
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		bit	7, b
		jr	z, kdo_x4
		dec	de
		ld	a, (de)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
kdo_x4:		call	outminus	; Ausgabe '-'-Zeichen, nchstes Zeichen lesen
		ret	c
		jr	z, kdo_x6
		push	hl
		push	bc
		call	param1		; 1 Parameter holen; das aktuelle Zeichen gehrt schon zum Parameter
		pop	hl
		pop	af
		push	bc
		push	af
		ld	a, l
		ld	(de), a
		pop	bc
		bit	7, b
		jr	z, kdo_x5
		inc	de
		ld	a, h
		ld	(de), a
kdo_x5:		pop	bc
		pop	hl
		ld	a, b
		cp	0Dh
		ret	z
kdo_x6:		bit	7, (hl)
		ret	nz
		jr	kdo_x3

; Register anzeigen
kdo_x7:		call	out_crlf
kdo_x8:		call	outsp		; Leerzeichen ausgeben
		ld	a, (hl)
		inc	hl
		or	a
		ret	m
		ld	c, a
		call	zm_conso	; Zeichenausgabe
		ld	c, '='
		call	zm_conso	; Zeichenausgabe
		ld	a, (hl)
		ld	b, a
		and	3Fh
		inc	hl
		ex	de, hl
		ld	l, a
		ld	h, 0
		add	hl, sp
		ex	de, hl
		bit	6, b
		jr	nz, kdo_x10
		ld	a, (de)
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		bit	7, b
		jr	z, kdo_x8
		dec	de
		ld	a, (de)
kdo_x9:		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		jr	kdo_x8
kdo_x10:	push	hl
		ld	a, (de)
		ld	h, a
		dec	de
		ld	a, (de)
		ld	l, a
		ld	a, (hl)
		pop	hl
		jr	kdo_x9

;------------------------------------------------------------------------------
; Ausgabe der Systemmeldung
;------------------------------------------------------------------------------

zmmsg:		ld	hl, aZ9001Monitor3_ ; "\r\n\f\a	Z9001 MONITOR 3.02  F.S.\r\n"

;Stringausgabe, HL=String, B=Lnge
zmmsg1:		ld	c, (hl)
		inc	hl
		call	zm_conso	; Zeichenausgabe
		djnz	zmmsg1
		call	zm_csts
		or	a
		ret	z
		call	consid7		; Zeicheneingabe + Lschen 7. Bit
		cp	3		; <STOP> ?
		jr	z, error0	; dann Abbruch
		jp	consid7		; Zeicheneingabe + Lschen 7. Bit
;
error:		ld	c, 7
		call	zm_conso	; Zeichenausgabe
		ld	c, '*'
		call	zm_conso	; Zeichenausgabe
error0:		call	eor0
		ld	de, -16h
		add	hl, de
		ld	sp, hl
		jp	prompt

; Zeicheneingabe und Vergleich mit D
readd:		call	zm_readi
		cp	d
		ret

;------------------------------------------------------------------------------
; Ausgabe der hchsten RAM-Adresse (RAM-TOP)
;------------------------------------------------------------------------------

kdo_z:		call	eor0
		ld	bc, tab_reg-regrstor
		add	hl, bc

; Ausgabe CR,LF, HL hexa 4 Stellen, SP
outnlhlsp:	call	out_crlf

; Ausgabe HL + Space
outhlsp:	call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen

; Leerzeichen ausgeben
outsp:		ld	c, ' '
		jp	zm_conso	; Zeichenausgabe

;
pun_crlf:	ld	c, 0Dh
		call	zm_puno
		ld	c, 0Ah
		jp	zm_puno

;------------------------------------------------------------------------------
; N (Null): Ausgabe von binren Nullen auf den Punch-Kanal.
; (Lochbandvorschub, sinnlos bei AP=T)
;------------------------------------------------------------------------------

null:		call	punch_init
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

; Konvertierung	low Nibble A in	Hex Ascii
toasc:		and	0Fh
		add	a, 90h
		daa
		adc	a, 40h
		daa
		ld	c, a
		ret


; zwei Parameter holen (HL, DE := DE|HL+003F)
twoparams:	call	params		; C Parameter holen
		pop	de		; parameter 2
		pop	hl		; parameter 1
		push	hl
		ld	a, d		; paramter 2 = 0?
		or	e
		jr	nz, twopar1	; nein
		ld	de, 3Fh	; '?'   ; ja: 003F zum 1. Parameter addieren
		add	hl, de
		ex	de, hl
twopar1:	pop	hl


; CR+LF ausgeben
out_crlf:	push	hl
		ld	b, 2		; Ausgabe der ersten zwei Zeichen der Systemmeldung (CR+LF)
		call	zmmsg		; Ausgabe der Systemmeldung
		pop	hl
		ret


; 3 Parameter holen -> HL, DE, BC
threeparams:	inc	c
		call	params		; C Parameter holen 
		call	out_crlf
		pop	bc
		pop	de
		pop	hl
		ret

; 1 Parameter holen
param:		ld	c, 1

; C Parameter holen
params:		ld	hl, 0
params1:	call	zm_char		; Eingabe Buchstabe oder ENTER
params2:	ld	b, a		; Zeichen sichern
		call	test_ziff	; Test auf Ziffer
		jr	c, params3	; Parameter auf	Stack legen
		add	hl, hl		; HL :=	HL*10h
		add	hl, hl
		add	hl, hl
		add	hl, hl
		or	l
		ld	l, a		; neue Ziffer dazuaddieren
		jr	params1
params3:	ex	(sp), hl	; Parameter auf	Stack legen
		push	hl
		ld	a, b		; Zeichen restaurieren
		call	tst_next	; folgt	Leerzeichen, Komma (Z=1) oder Enter (Cy=1)?
		jr	nc, params4
		dec	c
		ret	z
params4:	jp	nz, error
		dec	c
		jr	nz, params
		ret

; 1 Parameter holen; das aktuelle Zeichen gehrt schon zum Parameter
param1:		ld	c, 1
		ld	hl, 0
		jr	params2

;
nextadr1:	call	nextadr		; incl HL, HL=0	oder HL=DE?
		ret	nc
		inc	sp
		inc	sp
		ret

; incl HL, HL=0	oder HL=DE?
nextadr:	inc	hl
		ld	a, h
		or	l
		scf
		ret	z
nextadr0:	ld	a, e
		sub	l
		ld	a, d
		sbc	a, h
		ret

;------------------------------------------------------------------------------
; H   Bildung der Summe und Differenz
;     zweier Hexzahlen
;       H zahl1_zahl2
;------------------------------------------------------------------------------

kdo_h:		call	twoparams
		push	hl
		add	hl, de
		call	outhlsp		; Ausgabe HL + Space
		pop	hl
		or	a
		sbc	hl, de

; Ausgabe HL hexadezimal ASCII 4 Stellen
outhl:		ld	a, h
		call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		ld	a, l

; Ausgabe A hexadezimal	ASCII 2	Stellen
outah:		push	af
		rrca
		rrca
		rrca
		rrca
		call	outah1
		pop	af
outah1:		call	toasc		; Hex -> ASCII
		jp	zm_conso	; Zeichenausgabe

;------------------------------------------------------------------------------
; zu Punch
;------------------------------------------------------------------------------

punch_init0:	ld	bc, 8FFh
		jr	puni1

; Ausgabe 72 Nullen auf	Punch
punch_init:	ld	bc, 4800h	; B = 48h, C = 0
puni1:		call	zm_puno
		djnz	puni1
		ret

;
read_ziff:	call	readd7		; Zeicheneingabe 7 Bit

; Test auf Ziffer
test_ziff:	sub	30h ; '0'
		ret	c
		cp	17h
		ccf
		ret	c
		cp	0Ah
		ccf
		ret	nc
		sub	7
		cp	0Ah
		ret

; Ausgabe HL auf PUNCH
punch_hl:	ld	a, h
		call	punch_a		; Ausgabe A auf	PUNCH
		ld	a, l

; Ausgabe A auf	PUNCH
punch_a:	push	af
		rrca
		rrca
		rrca
		rrca
		call	toasc		; Hex -> ASCII
		call	zm_puno
		pop	af
		push	af
		call	toasc		; Hex -> ASCII
		call	zm_puno
		pop	af
		add	a, d
		ld	d, a
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

; Ausgabe '-'-Zeichen, nchstes Zeichen lesen
outminus:	ld	c, 2Dh ; '-'
		call	zm_conso	; Zeichenausgabe

; nchstes Zeichen lesen; Test auf Leerzeichen oder Enter
getch:		call	zm_char		; Eingabe Buchstabe oder ENTER

; folgt	Leerzeichen, Komma (Z=1) oder Enter (Cy=1)?
tst_next:	cp	' '
		ret	z
		cp	','
		ret	z
		cp	0Dh
		scf
		ret	z
		ccf
		ret

; Zeicheneingabe 7 Bit
readd7:		call	readd		; Zeicheneingabe und Vergleich mit D
		and	7Fh
		ret

;------------------------------------------------------------------------------
; K (Kassette):		Tapelook
;------------------------------------------------------------------------------

kdo_k:		ld	hl, CONBU
		ld	(DMA), hl
		call	requ
		ret	c

kdo_k1:		call	out_crlf
kdo_k2:		call	marek
		call	inita
		push	af
		ld	a, (6Bh)
		call	outah
		pop	af
		ld	c, ' '
		jr	nc, kdo_k3
		ld	c, '?'
kdo_k3:		call	zm_conso	; Zeichenausgabe
		call	outsp		; Leerzeichen ausgeben
		call	stopkey
		ret	c
		ld	a, (6Bh)
		inc	a
		jr	z, kdo_k
		dec	a
		jr	z, kdo_k3a
		dec	a
		jr	nz, kdo_k2
kdo_k3a:	ld	hl, kdo_k1
		push	hl
		ld	hl, 80h
		ld	de, 97h
kdo_k4:		call	display2
		call	outsp		; Leerzeichen ausgeben
		ld	b, 8
		call	type3
		ret	c
		call	out_crlf
		ld	b, 4
kdo_k5:		call	outsp		; Leerzeichen ausgeben
		djnz	kdo_k5
		jr	kdo_k4

;------------------------------------------------------------------------------
; L (Laden):		Laden von Programmen, die auf Festwert-
; 			speicher vorliegen und der Konventionen
; 			fr das	symbolische Aufrufen von Anwender-
; 			programmen des 0S-Z 9001 entsprechen.
; 
; 			L<name>^
; 			Name: max. 8 Buchstaben	oder Zahlen, wobei
; 			des erste Zeichen ein Buchstabe	sein muss.
;------------------------------------------------------------------------------
 
kdo_l:		ld	hl, 0F5EAh
		push	hl
		ld	a, i
		cp	2
		jr	z, kdo_l1
		call	sub_CEDB
		ex	de, hl
		ld	hl, 100h
		ld	bc, 53h
		ldir
kdo_l1:		ld	c, 0Ah
		ld	de, 80h
		ld	a, 28h
		ld	(de), a
		call	bdos0
		call	coext
		call	gval
		call	cprom
		push	af
		ld	a, i
		cp	2
		jr	z, kdo_l2
		push	hl
		call	sub_CEDB
		ld	de, 100h
		ld	bc, 53h
		ldir
		pop	hl
kdo_l2:		pop	af
		jp	nz, error
		jp	(hl)

;------------------------------------------------------------------------------
; Kommando U, Umschaltung 20Z/24Z
;------------------------------------------------------------------------------

kdo_u:		in	a, (PIO1AD)	; PIO1 A Daten Beeper, Border, 20Z
		xor	4
		out	(PIO1AD), a	; PIO1 A Daten Beeper, Border, 20Z
		bit	2, a
		ld	h, 21		; letzte zu rollende Zeile + 1 
		jr	nz, kdo_u1
		ld	h, 25		; letzte zu rollende Zeile + 1 
kdo_u1:		ld	l, 0		; 1. rollende Zeile - 1
		ld	(3Bh), hl	; P1ROL+P2ROL
		ret

;------------------------------------------------------------------------------
; TRAP
; wird bei RST 38 ausgefhrt
;------------------------------------------------------------------------------

trap:		push	hl
		push	de
		push	bc
		push	af
		call	eor0
		ex	de, hl
		ld	hl, 0Ah
		add	hl, sp
		ld	b, 4
		ex	de, hl
trap1:		dec	hl
		ld	(hl), d
		dec	hl
		ld	(hl), e
		pop	de
		djnz	trap1
		pop	bc
		dec	bc
		ld	sp, hl
		ld	hl, 25h
		add	hl, sp
		ld	a, (hl)
		sub	c
		inc	hl
		jr	nz, trap2
		ld	a, (hl)
		sub	b
		jr	z, trap4
trap2:		inc	hl
		inc	hl
		ld	a, (hl)
		sub	c
		jr	nz, trap3
		inc	hl
		ld	a, (hl)
		sub	b
		jr	z, trap4
trap3:		inc	bc
trap4:		ld	hl, 20h
		add	hl, sp
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
		inc	hl
		ld	(hl), c
		inc	hl
		ld	(hl), b
		push	bc
		ld	c, '$'
		call	zm_conso	; Zeichenausgabe
		pop	hl
		call	outhl		; Ausgabe HL hexadezimal ASCII 4 Stellen
		ld	hl, 25h
		add	hl, sp
		ld	bc, 200h
trap5:		ld	e, (hl)
		ld	(hl), c
		inc	hl
		ld	d, (hl)
		ld	(hl), c
		inc	hl
		ld	a, e
		or	d
		jr	z, trap6
		ld	a, (hl)
		ld	(de), a
trap6:		inc	hl
		djnz	trap5
		ex	af, af'
		exx
		push	hl
		push	de
		push	bc
		push	af
		push	ix
		push	iy
		ld	a, i
		ld	b, a
		ld	a, r
		ld	c, a
		push	bc
		jp	prompt

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

; Zeicheneingabe + Lschen 7. Bit
consid7:	call	zm_consi
		and	7Fh
		ret

; Eingabe Buchstabe oder ENTER
zm_char:	call	consid7		; Zeicheneingabe + Lschen 7. Bit
		ret	z
		inc	a
		ret	m
		dec	a
		cp	0Dh
		ret	z
		push	bc
		ld	c, a
		call	zm_conso	; Zeichenausgabe
		ld	a, c
		pop	bc
		cp	40h ; '@'
		ret	c
		cp	7Bh ; '{'
		ret	nc
		and	5Fh
		ret

;------------------------------------------------------------------------------
;  Q   Lesen und Schreiben auf I/O-Ports
;------------------------------------------------------------------------------

kdo_q:		call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	'O'
		jr	z, kdo_qo
		cp	'I'
		jp	nz, error

;Porteingabe
		call	param
		pop	bc
		in	e, (c)

; Ausgabe E binr
bin_e:		ld	b, 8
		call	outsp		; Leerzeichen ausgeben
bin_e1:		sla	e
		ld	a, 18h
		adc	a, a		; 2*18h	(="0') oder 2*18h+1 (="1')
		ld	c, a
		call	zm_conso	; Zeichenausgabe
		djnz	bin_e1
		ret

; Portausgabe
kdo_qo:		call	params
		pop	de
		pop	bc
		out	(c), e
		ret

;------------------------------------------------------------------------------
; V   Vergleich eines Speicherbereiches
;     mit einem anderen
;       V anfadr_endadr_zieladr
;------------------------------------------------------------------------------

kdo_v:		call	threeparams
kdo_v1:		ld	a, (bc)		; Zieladr
		cp	(hl)		; Anfangsadr
		jr	z, kdo_v2	; wenn gleich
		push	bc
;sonst Anzeige der Unterschiede
		call	outmem
		pop	bc
kdo_v2:		inc	bc
		call	nextadr1
		jr	kdo_v1


;------------------------------------------------------------------------------
; Liste der Zuweisungsmglichkeiten fr Assign
;------------------------------------------------------------------------------

tab_asgn:	db 'C'
;
		db 'C'
		db 'V'
		db 'B'
		db 'U'
;
		db 'R'
;
		db 'C'
		db 'P'
		db 'T'
		db 'U'
;
		db 'P'
;
		db 'C'
		db 'P'
		db 'T'
		db 'U'
;
		db 'L'
;
		db 'C'
		db 'V'
		db 'L'
		db 'U'

;------------------------------------------------------------------------------
; Register restaurieren
; s. init2
; Register sichern s. rst38
;------------------------------------------------------------------------------

regrstor:	pop	bc
		ld	a, c
		ld	r, a
		ld	a, b
		ld	i, a
		pop	iy
		pop	ix
		pop	af
		pop	bc
		pop	de
		pop	hl
		ex	af, af'
		exx
		pop	de
		pop	bc
		pop	af
		pop	hl
		ld	sp, hl
		nop
		ld	hl, 0
		jp	0

		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		
;------------------------------------------------------------------------------
; Tabellen fr Registeranzeige
;------------------------------------------------------------------------------

tab_reg:	db 'A'
		db  15h			; Stackoffset Register
		db 'B'
		db  13h
		db 'C'
		db  12h
		db 'D'
		db  11h
		db 'E'
		db  10h
		db 'F'
		db  14h
		db 'H'
		db  31h
		db 'L'
		db  30h
		db 'M'
		db 031h+11000000b
		db 'P'
		db 034h+10000000b
		db 'S'
		db  17h+10000000b
		db 'I'
		db    3
		db 0C1h			; bit7=1 Tabellenende
;Schattenregister
tab_reg2:	db 'A'
		db    9
		db 'B'
		db  0Bh
		db 'C'
		db  0Ah
		db 'D'
		db  0Dh
		db 'E'
		db  0Ch
		db 'F'
		db    8
		db 'H'
		db  0Fh
		db 'L'
		db  0Eh
		db 'M'
		db  0Fh+11000000b
		db 'X'
		db  07h+10000000b
		db 'Y'
		db  05h+10000000b
		db 'R'
		db    2
		db 0C1h			; bit7=1 Tabellenende


;------------------------------------------------------------------------------
; Systemaufrufe
;------------------------------------------------------------------------------

zm_consi:	push	bc
		ld	c, 1		; CONSI: Eingabe eines Zeichens von CONST
		jr	syscall1

;
zm_readi:	push	bc
		ld	c, 3		; READI: Eingabe eines Zeichens von READ
		jr	syscall1

; Zeichenausgabe
zm_conso:	ld	a, c
		jp	outa		; Ausgabe A

;
loc_C85A:	ld	a, (54h)
		cp	0FFh
		jr	z, loc_C884
		ld	hl, (50h)
		ld	(hl), c
		dec	hl
		ld	(50h), hl
		dec	a
		ld	(54h), a
		jr	nz, loc_C882
		dec	a
		ld	(54h), a
		ld	de, (52h)
		ld	c, 18
		call	bdos0
loc_C87C:	ld	hl, 53h
		ld	(50h), hl
loc_C882:	or	a
		ret
;
loc_C884:	ld	a, 1Bh
		cp	c
		jp	nz, 0F00Ch
		ld	a, 2
		ld	(54h), a
		jr	loc_C87C

;
zm_puno:	push	bc
		push	de
		ld	e, c
		ld	c, 4		; PUNO: Ausgabe eines Zeichens zu PUNCH
		jr	syscall2

; wird nicht genutzt
zm_listo:	push	bc
		push	de
		ld	e, c
		ld	c, 5		; LISTO: Ausgabe eines Zeichens zu LIST
		jr	syscall2


;
zm_csts:	push	bc
		ld	c, 11		; CSTS: Abfrage Status CONST

;
syscall1:	push	de
syscall2:	push	hl
		call	5
		pop	hl
		pop	de
		pop	bc
		jp	c, error
		ret

;------------------------------------------------------------------------------
; TTY-Treiber fr CONST (wie OS, aber mit Tastaturklick)
;------------------------------------------------------------------------------

const:		call	crt
		push	af
		ld	a, (PU)		; Hilfszelle (aufgerufene Treiberfunktion ?)	
		dec	a
		call	z, beep
		pop	af
		ret

; kurzen Ton ausgeben (Tastaturklick)
beep:		push	bc
		ld	b, 0
		ld	c, 14h
		ld	a, 00000111b
		out	(CTC0),	a	; System CTC0 Kassette,	Beeper
		ld	a, 10010110b
		out	(CTC0),	a	; System CTC0 Kassette,	Beeper
		in	a, (PIO1AD)
		set	7, a		; Beeper ein
		out	(PIO1AD), a	; PIO1 A Daten Beeper, Border, 20Z
;
beep1:		djnz	beep1
		dec	c
		jr	nz, beep1
		res	7, a		; Beeper aus
		out	(PIO1AD), a	; PIO1 A Daten Beeper, Border, 20Z
		ld	a, 00000011b
		out	(CTC0),	a	; System CTC0 Kassette,	Beeper
		pop	bc
		ret

;
stopkey:	call	0FD33h
		ei
		sub	3
		or	a
		ret	nz
		ld	(KEYBU), a
		scf
		ret

;------------------------------------------------------------------------------
; LST-Treiber fr LIST
; wird nicht genutzt (?)
;------------------------------------------------------------------------------

list0:		res	7, c
list:		ld	a, 11001111b
		out	(PIO1BS), a	; PIO1 B Kommando Anwenderport
		ld	a, 11111110b
		out	(PIO1BS), a	; PIO1 B Kommando Anwenderport
list1:		call	stopkey
		jr	nc, list2
		ld	(LISW), a
		ret
;
list2:		in	a, (PIO1BD)	; PIO1 B Daten Anwenderport
		add	a, a
		jr	c, list1
		ld	a, c
		cp	7Fh
		jr	z, list3
		cp	0FFh
		jr	nz, list4
list3:		ld	a, 1Bh
list4:		call	list5
		or	a
		ret
;
list5:		ld	e, 26h		; Zeitkonstante 4800 Baud (?)
		ld	b, 9
		and	7Fh
		di
		rla
list6:		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
		call	list7
		rra
		djnz	list6
		cpl
		out	(PIO1BD), a	; PIO1 B Daten Anwenderport
		ei
;
list7:		push	bc
		ld	b, e
list8:		djnz	list8
		pop	bc
		ret

;------------------------------------------------------------------------------
; aktueller LST-Treiber
; CENTRONICS-Druckerschnittstelle ueber User-Port
;------------------------------------------------------------------------------

lst:		inc	a		; A=FF (=Treiberinitialisierung) ?
		ret	z		; ja
		dec	a		; A=0 (=Abfrage Status)?
		cpl
		ret	z		; Rckgabe A=FFH bei Abfrage Status
;
		ld	a, 0CFh
		out	(PIO1BS), a
		xor	a
		out	(PIO1BS), a
		ld	a, 57h		;Zaehler,pos. Planke
		out	(CTC1),	a
		out	(CTC1),	a	;INIT CTC-1
		ld	a, c
		or	80h		;/STROBE=HIGH
		cp	0FFh
		jr	nz, lst1
		ld	a, 1Bh
lst1:		out	(PIO1BD), a	;Zeichen ohne Strobe
		and	7Fh		;/STROBE=LOW
		out	(PIO1BD), a	;Daten gueltig
		or	80h		;/STROBE=HIGH
		out	(PIO1BD), a
lst2:		call	stopkey		; Stop-Taste?
		ret	c
		in	a, (CTC1)
		cp	57h		;/ACKNLG?
		jr	z, lst2		;nein, warten
		xor	a
		ret

;------------------------------------------------------------------------------
; UR1-Treiber
;------------------------------------------------------------------------------

ur1:		ld	a, 0FFh
		ld	(PSUM), a
		exx
		ld	(0EFF4h), hl
		exx
		jr	ur12

; UP1-Treiber fr PUNCH
ur11:		xor	a
		ld	(PSUM), a
ur12:		ld	sp, (0Bh)
		pop	hl
		pop	hl
		pop	de
		ld	(AADR), hl
		ld	(EADR), de
		call	eor0
		ld	de, -16h
		add	hl, de
		ld	sp, hl
		ld	hl, prompt
		push	hl
		ld	a, (PSUM)
		or	a
		jr	nz, ur14
		ld	bc, 100Bh	; B=10h, C=0Bh 
		call	zm_conso	; Zeichenausgabe
		ld	c, 9
ur13:		call	zm_conso	; Zeichenausgabe
		djnz	ur13
		call	param
		pop	hl
		ld	(SADR), hl
		call	out_crlf
ur14:		ld	hl, error
		push	hl

;------------------------------------------------------------------------------
;Kassetten-Ein/-Ausgabe
;	Mit dieser Funktion sind Speicherbereiche als
;	Files von/auf Kassette lad-/entladbar.
;
;	Eintrittsparameter:
;	(69H)	: =0 Aus-, sonst Eingabe
;	(58H)	: Verschiebung bei Eingabe
;	(6DH)	: Anfangsadr. fr Ausgabe
;	(6FH)	: Endeadr. fr Ausgabe
;	(71H)	: Startadr.
;------------------------------------------------------------------------------

cass:		ld	de, aFilename	; "Filename:"
		call	bd_prnst
		ld	de, FNAME-1
		call	getfn		; Get Filename
		ld	a, (PSUM)
		or	a
		jr	nz, cload
		ld	a, (FNAME)
		cp	' '
		ret	z
		call	cass1
		ld	hl, varcass
		ld	b, (hl)
		ld	(hl), 0FFh
		push	bc
		call	csave
		pop	bc
		ld	a, b
		ld	(varcass), a
		ret	c
		pop	hl
		ret

; Filenamen Leerzeichen	-> 00
cass1:		ld	b, 11
		ld	hl, FNAME
cass2:		ld	a, (hl)
		cp	' '
		jr	nz, cass3
		ld	(hl), 0
cass3:		inc	hl
		djnz	cass2
		ret

aFilename:	db "Filename:",0

; Laden
cload:		ld	hl, CONBU	; CCP-Eingabepuffer und	Standardpuffer fr Kassetten-E/A
		ld	(DMA), hl
cload1:		call	openr		; Open fr Kassette lesen
		jr	nc, cload3
		or	a
		scf
		ret	z
		cp	0Dh
		jr	nz, cload2
		ld	b, a
		ld	a, (FNAME)
		cp	' '
		jr	z, cload3
		ld	a, b
cload2:		scf
		call	rea		; Ausgabe Fehlermeldung; warten	auf Bedienerreaktion
		jr	cload1
;
cload3:		ld	hl, CONBU
		call	dspfn		; Filename anzeigen
		ld	a, (CONBU)
		cp	' '
		ld	hl, 100h	; Anfangsadresse bei CP/M
		jr	nc, cload4
		ld	(SADR), hl
		ld	(AADR), hl
		ld	hl, (36h)	; EOR
		ld	(EADR), hl
cload4:		ld	de, (0EFF4h)
		ld	hl, (AADR)
		add	hl, de
		call	outhlsp
		ld	hl, (EADR)
		add	hl, de
		call	outhlsp
		ld	hl, (SADR)
		call	outhlsp
		ld	hl, (AADR)
		ld	de, (0EFF4h)
		add	hl, de
		ld	(DMA), hl
		call	loa55		; LESEN BLOCK
		ret	c
		pop	hl
		ld	hl, (SADR)
		jp	read7

; Speichern
csave:		ld	hl, (EADR)
		ld	de, (AADR)
		or	a
		sbc	hl, de
		ret	c
		ld	c, 15		; openw
		call	bdos0
		ret	c
		ex	de, hl
		ld	(DMA), hl
cave1:		ld	hl, (DMA)
		ld	de, 7Fh
		add	hl, de
		ld	de, (EADR)
		sbc	hl, de
		jr	nc, csave2
		ld	c, 21		; writs
		call	bdos0
		ret	c
		call	outblnr		; Blocknummer anzeigen
		ret	c
		jr	cave1
csave2:		ld	c, 16		; closw
		call	bdos0
		ret	c
		ld	de, aVrfyN	; "\n\rVrfy? N\b"
		call	bd_prnst
		call	zm_char		; Eingabe Buchstabe oder ENTER
		cp	'Y'
		scf
		ccf
		ret	nz
; Verify
		ld	de, aRewind	; " <="
		call	bd_prnst
csave3:		ld	hl, CONBU
		ld	(DMA), hl
		ld	c, 13		; openr
		call	bdos0
		jr	c, csave4
		call	stopkey
		jr	nc, csave5
		ret
;
csave4:		or	a
		ret	z
		call	rea1		; Ausgabe Fehlermeldung; warten	auf Bedienerreaktion
		ret	c
		jr	csave3
;
csave5:		ld	c, 20		; reads
		call	bdos0
		jr	nc, csave6
		call	rea1		; Ausgabe Fehlermeldung; warten	auf Bedienerreaktion
		ret	c
		jr	csave5
;
csave6:		ld	l, a
		call	stopkey
		ret	c
		ld	a, l
		ld	hl, CONBU
		ld	(DMA), hl
		or	a
		jr	z, csave5
		ret

aVrfyN:		db 0Ah
		db 0Dh,"Vrfy? N",8,0
aRewind:	db " <=",0

;------------------------------------------------------------------------------
; BDOS-Aufrufe OS bzw. CCP
;------------------------------------------------------------------------------

bd_prnst:	ld	c, 9
		jp	bdos0

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

; Blocknummer anzeigen
outblnr:	call	outah		; Ausgabe A hexadezimal	ASCII 2	Stellen
		ld	c, 8
		call	zm_conso	; Zeichenausgabe
		call	zm_conso	; Zeichenausgabe
		jp	stopkey



;------------------------------------------------------------------------------
; Startbereich fr OS-Kommandos
;------------------------------------------------------------------------------

; vp: im Original ist der Bereich bis zur nchsten Page mit 00 gefllt
; auerdem wird eine Page bersprungen, deshalb steht hier org

		db	(($+01ffh)/100h)*100h-$ dup (000h)	; mit 00 auffllen
		org	beg+0c00h

		jp	cmd_eor
		db "#       ",0
		jp	cmd_zm
aZm:		db "ZM      ",0
		jp	cmd_rzm
aRzm:		db "RZM     ",0
		jp	cmd_basic
aBasic:		db "BASIC   ",0
		jp	cmd_bitex
aBitex:		db "BITEX   ",0
		db    0

;------------------------------------------------------------------------------
; "#       " OS-Erweiterung
;------------------------------------------------------------------------------

cmd_eor:	ld	de, aEos	; "\v\x14\x01EOS\x14\x02$"
		ld	c, 9
		call	5
;
		ld	de, 0EFC9h	
		ld	hl, tab_treiber	; Tabelle der Gertetreiber
		ld	bc, 20h		; aEOS-tab_treiber
		ldir
;
		ld	a, 0CFh
		out	(PIO1BS), a
		ld	a, 7Fh
		out	(PIO1BS), a
		xor	a
		ld	(0EFF3h), a
		cpl
		out	(PIO1BD), a
		ld	hl, 0F089h
		push	hl
		ret

;------------------------------------------------------------------------------
; "BASIC"
;------------------------------------------------------------------------------

cmd_basic:		jp	cmd_zm

;------------------------------------------------------------------------------
; "BITEX"
;------------------------------------------------------------------------------

cmd_bitex:	call	kdo_i1
		ld	hl, 0D000h
		ld	de, 100h
		ld	bc, 1500h
		ldir
		jp	15E4h

;------------------------------------------------------------------------------
; Tabelle der Gertetreiber
;------------------------------------------------------------------------------

tab_treiber:	dw const	; TTY-Treiber fr CONST
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
		dw bat		; BAT: STEUERPROGRAMM FUER BATCH-MODE VON CONST
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
;
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
		dw 0FFFFh
		dw ur1		; UR1-Treiber fr READER
		dw 0FFFFh
;
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
		dw 0FFFFh
		dw ur11		; UP1-Treiber fr PUNCH
		dw 0FFFFh
;
		dw crt		; CRT: STEUERPROGRAMM DES CRT - TREIBERS
		dw 0FFFFh
		dw lst		; LST-Treiber fr LIST
		dw 0FFFFh

; EOS-Systemmeldung
aEos:		db 0Bh,14h,1,"EOS",14h,2,0,'$'

;------------------------------------------------------------------------------
; CP/M-BDOS
;------------------------------------------------------------------------------

bdos0:		scf
		ccf
		jr	bdos1

; BDOS-Sprungverteiler
bdos:		scf
bdos1:		push	af
		ld	a, i
		cp	2		; OS-Mode ?
		jr	nz, bdos2	; nein -> CP/M-Mode
		pop	af
		jp	bos		; Eintritt OS-BOS
;
bdos2:		push	hl
		ld	h, a
		ld	l, 60h
		ld	(0Dh), hl
		pop	hl
		pop	af
		ld	(0Bh), sp
		ld	sp, (0Dh)
		jp	nc, unk_F31B
		ccf
		push	hl
		push	de
		push	af
		push	bc
		ld	(0Dh), bc
		ld	(0Fh), a
		ld	hl, bdos_os	; Systemrufe, die direkt ins Z9001-OS gehen
		ld	a, c
		ld	bc, 11		; Anzahl
		cpir			; suchen
		pop	bc
		jp	z, unk_F327	; wenn gefunden, dann in OS-BOS-Systemrufverteiler
;
		ld	hl, bose	; BOSE:	AUSGANG	AUS BOS
		push	hl
		ld	b, 0
		ld	a, 37
		cp	c
		jp	c, boser	; BOSER
		ld	hl, bdos_zm	; ADRESSTABELLE	DER SYSTEMRUFE
		jp	unk_F336	; in BOS-Systemrufverteiler


; Systemrufe, die direkt ins Z9001-OS gehen
bdos_os:	db    1			; BDOS function	1 (C_READ) - Console input
		db    2			; BDOS function	2 (C_WRITE) - Console output
		db    3			; BDOS function	3 (A_READ) - Auxiliary (Reader)	input
		db    4			; BDOS function	4 (A_WRITE) - Auxiliary	(Punch)	output
		db    5			; BDOS function	5 (L_WRITE) - Printer output
		db    7			; BDOS function	7 - Get	I/O byte
		db    8			; BDOS function	8 - Set	I/O byte
		db 10			; BDOS function	10 (C_READSTR) - Buffered console input
		db 11			; BDOS function	11 (C_STAT) - Console status
		db 12			; BDOS function	12 (S_BDOSVER) - Return	version	number
		db 26

; Sprungverteiler BDOS (CP/M)
bdos_zm:	dw bd_reset             ; BDOS function	0 (P_TERMCPM) -	System Reset
		dw bdos_err             ; BDOS function	1 (C_READ) - Console input
		dw bdos_err             ; BDOS function	2 (C_WRITE) - Console output
		dw bdos_err             ; BDOS function	3 (A_READ) - Auxiliary (Reader)	input
		dw bdos_err             ; BDOS function	4 (A_WRITE) - Auxiliary	(Punch)	output
		dw bdos_err             ; BDOS function	5 (L_WRITE) - Printer output
		dw bd_rawio             ; BDOS function	6 (C_RAWIO) - Direct console I/O
		dw bdos_err             ; BDOS function	7 - Get	I/O byte
		dw bdos_err             ; BDOS function	8 - Set	I/O byte
		dw bd_writestr          ; BDOS function	9 (C_WRITESTR) - Output	string
		dw bdos_err             ; BDOS function	10 (C_READSTR) - Buffered console input
		dw bdos_err             ; BDOS function	11 (C_STAT) - Console status
		dw bdos_err             ; BDOS function	12 (S_BDOSVER) - Return	version	number
		dw bd_drvallreset       ; BDOS function	13 (DRV_ALLRESET) - Reset discs
		dw bd_noerr             ; BDOS function	14 (DRV_SET) - Select disc
		dw bd_fopen             ; BDOS function	15 (F_OPEN) - Open file
		dw bd_fclose            ; BDOS function	16 (F_CLOSE) - Close file
		dw bdos_err             ; BDOS function	17 (F_SFIRST) -	search for first
		dw bdos_err             ; BDOS function	18 (F_SNEXT) - search for next
		dw bd_noerr             ; BDOS function	19 (F_DELETE) -	delete file
		dw bd_fread             ; BDOS function	20 (F_READ) - read next	record
		dw bd_fwrite            ; BDOS function	21 (F_WRITE) - write next record
		dw bd_fopen             ; BDOS function	22 (F_MAKE) - create file
		dw bd_noerr             ; BDOS function	23 (F_RENAME) -	Rename file
		dw bd_drvvec            ; BDOS function	24 (DRV_LOGINVEC) - Return bitmap of logged-in drives
		dw bd_noerr             ; BDOS function	25 (DRV_GET) - Return current drive
		dw bdos_err             ; BDOS function	26 (F_DMAOFF) -	Set DMA	address
		dw bdos_err             ; BDOS function	27 (DRV_ALLOCVEC) - Return address of allocation map
		dw bdos_err             ; BDOS function	28 (DRV_SETRO) - Software write-protect	current	disc
		dw bd_drvrovec          ; BDOS function	29 (DRV_ROVEC) - Return	bitmap of read-only drives
		dw bdos_err             ; BDOS function	30 (F_ATTRIB) -	set file attributes
		dw bdos_err             ; BDOS function	31 (DRV_DPB) - get DPB address
		dw bdos_err             ; BDOS function	32 (F_USERNUM) - get/set user number
		dw bd_frrand            ; BDOS function	33 (F_READRAND)	- Random access	read record
		dw bd_fwrand		; BDOS function	34 (F_WRITERAND) - Random access write record
		dw bd_fsize		; BDOS function	35 (F_SIZE) - Compute file size
		dw bd_frrec		; BDOS function	36 (F_RANDREC) - Update	random access pointer
		dw bd_drvreset		; BDOS function	37 (DRV_RESET) - Selectively reset disc	drives

; BDOS error
bdos_err:	ld	a, 0FFh
		ld	(0Fh), a
		ret

; BDOS function	0 (P_TERMCPM) -	System Reset
bd_reset:	ld	sp, (0Bh)
		jp	cmd_rzm

; BDOS function	6 (C_RAWIO) - Direct console I/O
bd_rawio:	ld	a, 0FFh
		cp	e
		jp	nz, conso
		call	csts
		or	a
		call	nz, consi
		jp	bd_ret

; Filename anzeigen
dspfn:		ld	b, 11
dspfn1:		ld	a, (hl)
		call	outa		; Ausgabe A
		inc	hl
		djnz	dspfn1
		ld	bc, 5
		add	hl, bc
		call	ospac		; Ausgabe Leerzeichen
		ld	a, (hl)
		jp	outa		; Ausgabe A

; BDOS function	9 (C_WRITESTR) - Output	string
bd_writestr:	ex	de, hl
bd_writestr1:	ld	a, (hl)
		or	a
		ret	z
		cp	'$'
		ret	z
		call	outa
		inc	hl
		jr	bd_writestr1

; BDOS function	13 (DRV_ALLRESET) - Reset discs
bd_drvallreset:	ld	bc, CONBU
		jp	setdm

; BDOS function	22 (F_MAKE) - create file 
bd_fopen:	call	sub_CDA8
		ld	(hl), 0FFh
		xor	a
		ld	(6Bh), a
		ld	(6Ch), a
		ret

; indirekter Start durch sub_CDA8
loc_CD99:	xor	a
		ld	(0Fh), a
;
loc_CD9D:	pop	hl
		ld	(1Bh), hl
		pop	hl
		ld	a, h
		ld	(37h), a
		or	a
		ret
;
sub_CDA8:	ld	hl, 37h
		ld	a, (hl)
		ld	(hl), 0FFh
		ld	h, a
		pop	bc
		push	hl
		ld	hl, (1Bh)
		push	hl
		ld	hl, loc_CD99
		push	hl
		push	bc
		ld	hl, 11h
		add	hl, de
		ret
;

; BDOS function	16 (F_CLOSE) - Close file
bd_fclose:	call	sub_CDA8
		ld	b, (hl)
		ld	(hl), 43h	; 'C'
		in	a, (68h)
		ld	a, (4000h)
		cp	'U'
		in	a, (60h)
		jr	nz, bd_fclose8
		in	a, (68h)
		xor	a
		ld	(4000h), a
		ld	hl, 407Fh
		ld	a, 'U'
		ld	b, 7Fh

bd_fclose1:	cp	(hl)
		jr	z, bd_fclose2
		inc	hl
		djnz	bd_fclose1
		in	a, (60h)
		jr	bd_fclose9
;
bd_fclose2:	in	a, (60h)
		push	de
		push	bc
		ld	a, (6Bh)
		or	a
		jr	nz, bd_fclose3
		call	starttape
		jr	c, bd_fclose6
		ld	(1Bh), de
		ld	bc, 1770h
		call	0F472h
		jr	bd_fclose4
;
bd_fclose3:	ld	de, bd_fclose7+2
		call	starttape
		jr	c, bd_fclose6
;
bd_fclose4:	in	a, (68h)
		ld	hl, 4080h
		pop	bc
		ld	(1Bh), hl
bd_fclose5:	push	bc
		call	sub_CF65
		pop	bc
		djnz	bd_fclose5
		in	a, (60h)
		pop	de
		jr	bd_fclose9
;
bd_fclose6:	pop	bc
		pop	de
bd_fclose7:	jp	loc_CED2

;
		dec	a
		ld	a, 0Dh
		ld	a, (bc)
		nop

bd_fclose8:	ld	a, b
		cp	'R'
		ret	z
		cp	'W'
		ret	nz

bd_fclose9:	ld	a, 0FFh
		ld	(6Bh), a
		ld	bc, 0A0h
		ld	(1Bh), de
		jp	0F497h


; BDOS function	33 (F_READRAND)	- Random access	read record
bd_frrand:	ld	a, 0FFh
		jr	bd_fread1

; BDOS function	20 (F_READ) - read next	record
bd_fread:	xor	a
bd_fread1:	ld	(0EFF4h), a
		call	sub_CDA8
		ld	a, (hl)
		or	a
		jp	z, loc_CED2
		cp	0FFh
		jr	nz, bd_fread4
		ld	(hl), 'R'
		ld	a, (0EFF4h)
		or	a
		jr	nz, bd_fread4
bd_fread2:	call	starttape	; Anzeige "Start Tape" + Filename
		jr	c, loc_CED2
		call	sub_CEDB
		ld	(1Bh), hl
		push	de
		call	0F027h
		jr	nc, bd_fread3
		call	0F5A3h
		pop	de
		jr	c, loc_CED2
		jr	bd_fread2
;
bd_fread3:	pop	de
		ld	hl, 20h
		add	hl, de
		ld	a, (hl)
		inc	a
		ld	(6Ch), a
		call	0F2FEh
		call	sub_CEDB
		inc	hl
		call	dspfn
bd_fread4:	call	sub_CEDB
		ld	(1Bh), hl
		call	sub_CEAA
		jr	nc, bd_fread5
		call	0F5A3h
		jr	c, loc_CED2
		jr	bd_fread4
;
bd_fread5:	or	a
		jr	nz, loc_CED7
		call	sub_CEDB
		pop	bc
		pop	de
		push	de
		push	bc
		ld	bc, 80h
		ldir
		ret

;
sub_CEAA:	ld	a, (0EFF4h)
		or	a
		jp	z, 0F027h
		call	sub_CF41
		pop	bc
		jr	c, loc_CED2
		in	a, (68h)
		ld	a, (hl)
		cp	'U'
		in	a, (60h)
		ld	a, 1
		jr	nz, loc_CED4
		push	bc
		call	sub_CEDB
		ex	de, hl
		ld	bc, 80h
		in	a, (68h)
		ldir
		in	a, (60h)
		xor	a
		ret

;
loc_CED2:	ld	a, 0FFh
loc_CED4:	ld	(0Fh), a
loc_CED7:	pop	hl
		jp	loc_CD9D

;
sub_CEDB:	ld	a, i
		dec	a
		ld	h, a
		ld	l, 73h
		ret


; BDOS function	34 (F_WRITERAND) - Random access write record
bd_fwrand:	ld	a, 0FFh
		jr	bd_fwrite1

; BDOS function	21 (F_WRITE) - write next record
bd_fwrite:	xor	a
bd_fwrite1:	ld	(0EFF4h), a
		call	sub_CDA8
		ld	a, (hl)
		or	a
		jr	z, loc_CED2
		cp	0FFh
		jr	nz, bd_fwrite2
		ld	(hl), 'W'
		call	starttape
		jr	c, loc_CED2
		ld	hl, (1Bh)
		push	de
		push	hl
		ld	(1Bh), de
		ld	bc, 1770h
		call	0F472h
		pop	hl
		pop	de
		ld	(1Bh), hl
bd_fwrite2:	ld	a, (0EFF4h)
		or	a
		jr	z, sub_CF65
		in	a, (68h)
		ld	a, 'U'
		ld	(4000h), a
		in	a, (60h)
		call	sub_CEDB
		push	de
		ex	de, hl
		ld	bc, 80h
		ld	hl, (1Bh)
		ldir
		pop	de
		call	sub_CF41
		jr	c, loc_CED2
		in	a, (68h)
		ld	(hl), 'U'
		call	sub_CEDB
		ld	bc, 80h
		ldir
		in	a, (60h)
		ret

;
sub_CF41:	ld	hl, 21h
		add	hl, de
		ld	a, (6Bh)
		sub	(hl)
		neg
		cp	7Eh
		jr	nc, loc_CF63
		ld	h, a
		srl	h
		ld	l, 0
		rr	l
		ld	de, 4080h
		add	hl, de
		ex	de, hl
		ld	hl, 4001h
		ld	c, a
		ld	b, 0
		add	hl, bc
		ret
;
loc_CF63:	scf
		ret

;
sub_CF65:	call	writs
		ld	c, ' '
		jp	conso


; BDOS function	24 (DRV_LOGINVEC) - Return bitmap of logged-in drives
bd_drvvec:	pop	bc
		pop	af
		pop	de
		pop	hl
		ld	hl, 1		; nur LW "A"
bd_drvvec1:	push	hl
		push	de
		push	af
		push	bc

;
bd_noerr:	xor	a

;
bd_ret:		ld	(0Fh), a
		ret


; BDOS function	29 (DRV_ROVEC) - Return	bitmap of read-only drives
bd_drvrovec:	pop	bc
		pop	af
		pop	de
		pop	hl
		ld	hl, 0		; keins
		jr	bd_drvvec1

; BDOS function	35 (F_SIZE) - Compute file size
bd_fsize:	jr	bd_noerr
		nop

; BDOS function	36 (F_RANDREC) - Update	random access pointer
bd_frrec:	jr	bd_noerr
		nop

; BDOS function	37 (DRV_RESET) - Selectively reset disc	drives
bd_drvreset:	jr	bd_noerr
		db    0


; Anzeige "Start Tape" + Filename
starttape:	push	de
		push	de
		ld	de, txtrc	; "Start Tape"
		call	bd_writestr
		pop	hl
		inc	hl
		call	dspfn
		ld	c, ':'
		call	conso
		call	consi
		push	af
		ld	c, ' '
		call	conso
		pop	af
		pop	de
		cp	3		; <STOP> ?
		scf
		ccf
		ret	nz
		scf
		ret

;-----------------------------------------------------------------------------

; ab 0D000h Code von bitex, wird nach 1x00 verschoben

		end
