;-----------------------------------------------------------------------------
; Arbeitsspeicher 
;-----------------------------------------------------------------------------

IOBYT		equ	0004h		; IO-Byte (in SIO)
LISW		equ	0015h		; Schalter fr Hardcopy (in SIO)
DMA		equ	1Bh		; Zeiger auf Puffer fr	Kassetten-E/A


fcb1		equ	005Ch
fcb2		equ	006Ch
; Aufbau FCB
; 00	FDRIVE	Laufwerkscode (keins - 0, A - 1, B - 2)
; 01-08	FNAME	Dateiname, mit Leerzeichen aufgefllt
; 09-0B	FTYP	Dateityp, mit Leerzeichen aufgefllt
; 0C	PSUM
; 0D	ARB (?)
; 0E	BLNR
; 0F	LBLNR
; 10
; 11
; 12-13	AADR
; 14-15	EADR
; 16-17	SADR
; 18	SBY

CONBU		equ	0080h		; Eingabepuffer

;-----------------------------------------------------------------------------
; I/O
;-----------------------------------------------------------------------------

CTC0		equ	80h		; System CTC0 Kassette, Beeper
CTC1		equ	81h		; System CTC1 Anwenderport
CTC2		equ	82h		; System CTC2 Systemuhr
CTC3		equ	83h		; System CTC3 Systemuhr

PIO1AD		EQU	88H		; PIO1 A Daten Beeper, Border, 20Z
PIO1BD		EQU	89H		; PIO1 B Daten Anwenderport
PIO1AS		EQU	8AH		; PIO1 A Kommando
PIO1BS		EQU	8BH		; PIO1 B Kommando Anwenderport

PIO2AD		EQU	90H		; Tastatur-PIO2 A Daten
PIO2BD		EQU	91H		; Tastatur-PIO2 B Daten
PIO2AS		EQU	92H		; Tastatur-PIO2 A Kommando
PIO2BS		EQU	93H		; Tastatur-PIO2 B Kommando

;-----------------------------------------------------------------------------
; AS-Funktionen
;-----------------------------------------------------------------------------

; obere 8 Bit: hi(CONBU)
hi              function x,(x>>8)&255

; untere 8 Bit: lo(CONBU)
lo              function x, x&255

;nchste ..00h Grenze: org nextpage($)
nextpage	function x, ((x+0ffh)/100h)*100h

;align-Ersatz: db zalign(80h) dup (?)
zalign		function x, ((($+x-1)/x)*x - $)
